// jslint.js
// 2012-03-02

// Copyright (c) 2002 Douglas Crockford  (www.JSLint.com)

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// The Software shall be used for Good, not Evil.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

// WARNING: JSLint will hurt your feelings.

var JSLINT=(function(){function bT(cf,ce){var ax,cd=cf.length,F={};for(ax=0;ax<cd;ax+=1){F[cf[ax]]=ce}return F}var k,ao,bh,t,l={anon:true,bitwise:true,browser:true,cap:true,"continue":true,css:true,debug:true,devel:true,eqeq:true,es5:true,evil:true,forin:true,fragment:true,indent:10,maxerr:1000,maxlen:256,newcap:true,node:true,nomen:true,on:true,passfail:true,plusplus:true,properties:true,regexp:true,rhino:true,undef:true,unparam:true,sloppy:true,sub:true,vars:true,white:true,widget:true,windows:true},a9,bW,bd={"<":true,"<=":true,"==":true,"===":true,"!==":true,"!=":true,">":true,">=":true,"+":true,"-":true,"*":true,"/":true,"%":true},ad=bT(["arguments","callee","caller","constructor","eval","prototype","stack","unwatch","valueOf","watch"],true),c,aR=bT(["clearInterval","clearTimeout","document","event","frames","history","Image","localStorage","location","name","navigator","Option","parent","screen","sessionStorage","setInterval","setTimeout","Storage","window","XMLHttpRequest"],false),A={a_label:"'{a}' is a statement label.",a_not_allowed:"'{a}' is not allowed.",a_not_defined:"'{a}' is not defined.",a_scope:"'{a}' used out of scope.",adsafe_a:"ADsafe violation: '{a}'.",adsafe_autocomplete:"ADsafe autocomplete violation.",adsafe_bad_id:"ADSAFE violation: bad id.",adsafe_div:"ADsafe violation: Wrap the widget in a div.",adsafe_fragment:"ADSAFE: Use the fragment option.",adsafe_go:"ADsafe violation: Misformed ADSAFE.go.",adsafe_html:"Currently, ADsafe does not operate on whole HTML documents. It operates on <div> fragments and .js files.",adsafe_id:"ADsafe violation: id does not match.",adsafe_id_go:"ADsafe violation: Missing ADSAFE.id or ADSAFE.go.",adsafe_lib:"ADsafe lib violation.",adsafe_lib_second:"ADsafe: The second argument to lib must be a function.",adsafe_missing_id:"ADSAFE violation: missing ID_.",adsafe_name_a:"ADsafe name violation: '{a}'.",adsafe_placement:"ADsafe script placement violation.",adsafe_prefix_a:"ADsafe violation: An id must have a '{a}' prefix",adsafe_script:"ADsafe script violation.",adsafe_source:"ADsafe unapproved script source.",adsafe_subscript_a:"ADsafe subscript '{a}'.",adsafe_tag:"ADsafe violation: Disallowed tag '{a}'.",already_defined:"'{a}' is already defined.",and:"The '&&' subexpression should be wrapped in parens.",assign_exception:"Do not assign to the exception parameter.",assignment_function_expression:"Expected an assignment or function call and instead saw an expression.",attribute_case_a:"Attribute '{a}' not all lower case.",avoid_a:"Avoid '{a}'.",bad_assignment:"Bad assignment.",bad_color_a:"Bad hex color '{a}'.",bad_constructor:"Bad constructor.",bad_entity:"Bad entity.",bad_html:"Bad HTML string",bad_id_a:"Bad id: '{a}'.",bad_in_a:"Bad for in variable '{a}'.",bad_invocation:"Bad invocation.",bad_name_a:"Bad name: '{a}'.",bad_new:"Do not use 'new' for side effects.",bad_number:"Bad number '{a}'.",bad_operand:"Bad operand.",bad_style:"Bad style.",bad_type:"Bad type.",bad_url_a:"Bad url '{a}'.",bad_wrap:"Do not wrap function literals in parens unless they are to be immediately invoked.",combine_var:"Combine this with the previous 'var' statement.",conditional_assignment:"Expected a conditional expression and instead saw an assignment.",confusing_a:"Confusing use of '{a}'.",confusing_regexp:"Confusing regular expression.",constructor_name_a:"A constructor name '{a}' should start with an uppercase letter.",control_a:"Unexpected control character '{a}'.",css:"A css file should begin with @charset 'UTF-8';",dangling_a:"Unexpected dangling '_' in '{a}'.",dangerous_comment:"Dangerous comment.",deleted:"Only properties should be deleted.",duplicate_a:"Duplicate '{a}'.",empty_block:"Empty block.",empty_case:"Empty case.",empty_class:"Empty class.",es5:"This is an ES5 feature.",evil:"eval is evil.",expected_a:"Expected '{a}'.",expected_a_b:"Expected '{a}' and instead saw '{b}'.",expected_a_b_from_c_d:"Expected '{a}' to match '{b}' from line {c} and instead saw '{d}'.",expected_at_a:"Expected an at-rule, and instead saw @{a}.",expected_a_at_b_c:"Expected '{a}' at column {b}, not column {c}.",expected_attribute_a:"Expected an attribute, and instead saw [{a}].",expected_attribute_value_a:"Expected an attribute value and instead saw '{a}'.",expected_class_a:"Expected a class, and instead saw .{a}.",expected_fraction_a:"Expected a number between 0 and 1 and instead saw '{a}'",expected_id_a:"Expected an id, and instead saw #{a}.",expected_identifier_a:"Expected an identifier and instead saw '{a}'.",expected_identifier_a_reserved:"Expected an identifier and instead saw '{a}' (a reserved word).",expected_linear_a:"Expected a linear unit and instead saw '{a}'.",expected_lang_a:"Expected a lang code, and instead saw :{a}.",expected_media_a:"Expected a CSS media type, and instead saw '{a}'.",expected_name_a:"Expected a name and instead saw '{a}'.",expected_nonstandard_style_attribute:"Expected a non-standard style attribute and instead saw '{a}'.",expected_number_a:"Expected a number and instead saw '{a}'.",expected_operator_a:"Expected an operator and instead saw '{a}'.",expected_percent_a:"Expected a percentage and instead saw '{a}'",expected_positive_a:"Expected a positive number and instead saw '{a}'",expected_pseudo_a:"Expected a pseudo, and instead saw :{a}.",expected_selector_a:"Expected a CSS selector, and instead saw {a}.",expected_small_a:"Expected a small positive integer and instead saw '{a}'",expected_space_a_b:"Expected exactly one space between '{a}' and '{b}'.",expected_string_a:"Expected a string and instead saw {a}.",expected_style_attribute:"Excepted a style attribute, and instead saw '{a}'.",expected_style_pattern:"Expected a style pattern, and instead saw '{a}'.",expected_tagname_a:"Expected a tagName, and instead saw {a}.",expected_type_a:"Expected a type, and instead saw {a}.",for_if:"The body of a for in should be wrapped in an if statement to filter unwanted properties from the prototype.",function_block:"Function statements should not be placed in blocks. Use a function expression or move the statement to the top of the outer function.",function_eval:"The Function constructor is eval.",function_loop:"Don't make functions within a loop.",function_statement:"Function statements are not invocable. Wrap the whole function invocation in parens.",function_strict:"Use the function form of 'use strict'.",html_confusion_a:"HTML confusion in regular expression '<{a}'.",html_handlers:"Avoid HTML event handlers.",identifier_function:"Expected an identifier in an assignment and instead saw a function invocation.",implied_evil:"Implied eval is evil. Pass a function instead of a string.",infix_in:"Unexpected 'in'. Compare with undefined, or use the hasOwnProperty method instead.",insecure_a:"Insecure '{a}'.",isNaN:"Use the isNaN function to compare with NaN.",label_a_b:"Label '{a}' on '{b}' statement.",lang:"lang is deprecated.",leading_decimal_a:"A leading decimal point can be confused with a dot: '.{a}'.",missing_a:"Missing '{a}'.",missing_a_after_b:"Missing '{a}' after '{b}'.",missing_option:"Missing option value.",missing_property:"Missing property name.",missing_space_a_b:"Missing space between '{a}' and '{b}'.",missing_url:"Missing url.",missing_use_strict:"Missing 'use strict' statement.",mixed:"Mixed spaces and tabs.",move_invocation:"Move the invocation into the parens that contain the function.",move_var:"Move 'var' declarations to the top of the function.",name_function:"Missing name in function statement.",nested_comment:"Nested comment.",not:"Nested not.",not_a_constructor:"Do not use {a} as a constructor.",not_a_defined:"'{a}' has not been fully defined yet.",not_a_function:"'{a}' is not a function.",not_a_label:"'{a}' is not a label.",not_a_scope:"'{a}' is out of scope.",not_greater:"'{a}' should not be greater than '{b}'.",octal_a:"Don't use octal: '{a}'. Use '\\u....' instead.",parameter_arguments_a:"Do not mutate parameter '{a}' when using 'arguments'.",parameter_a_get_b:"Unexpected parameter '{a}' in get {b} function.",parameter_set_a:"Expected parameter (value) in set {a} function.",radix:"Missing radix parameter.",read_only:"Read only.",redefinition_a:"Redefinition of '{a}'.",reserved_a:"Reserved name '{a}'.",scanned_a_b:"{a} ({b}% scanned).",slash_equal:"A regular expression literal can be confused with '/='.",statement_block:"Expected to see a statement and instead saw a block.",stopping:"Stopping. ",strange_loop:"Strange loop.",strict:"Strict violation.",subscript:"['{a}'] is better written in dot notation.",tag_a_in_b:"A '<{a}>' must be within '<{b}>'.",too_long:"Line too long.",too_many:"Too many errors.",trailing_decimal_a:"A trailing decimal point can be confused with a dot: '.{a}'.",type:"type is unnecessary.",unclosed:"Unclosed string.",unclosed_comment:"Unclosed comment.",unclosed_regexp:"Unclosed regular expression.",unescaped_a:"Unescaped '{a}'.",unexpected_a:"Unexpected '{a}'.",unexpected_char_a_b:"Unexpected character '{a}' in {b}.",unexpected_comment:"Unexpected comment.",unexpected_else:"Unexpected 'else' after 'return'.",unexpected_property_a:"Unexpected /*property*/ '{a}'.",unexpected_space_a_b:"Unexpected space between '{a}' and '{b}'.",unnecessary_initialize:"It is not necessary to initialize '{a}' to 'undefined'.",unnecessary_use:"Unnecessary 'use strict'.",unreachable_a_b:"Unreachable '{a}' after '{b}'.",unrecognized_style_attribute_a:"Unrecognized style attribute '{a}'.",unrecognized_tag_a:"Unrecognized tag '<{a}>'.",unsafe:"Unsafe character.",url:"JavaScript URL.",use_array:"Use the array literal notation [].",use_braces:"Spaces are hard to count. Use {{a}}.",use_charAt:"Use the charAt method.",use_object:"Use the object literal notation {}.",use_or:"Use the || operator.",use_param:"Use a named parameter.",used_before_a:"'{a}' was used before it was defined.",var_a_not:"Variable {a} was not declared correctly.",weird_assignment:"Weird assignment.",weird_condition:"Weird condition.",weird_new:"Weird construction. Delete 'new'.",weird_program:"Weird program.",weird_relation:"Weird relation.",weird_ternary:"Weird ternary.",wrap_immediate:"Wrap an immediate function invocation in parentheses to assist the reader in understanding that the expression is the result of a function, and not the function itself.",wrap_regexp:"Wrap the /regexp/ literal in parens to disambiguate the slash operator.",write_is_wrong:"document.write can be a form of eval."},o,bU,b5,aB=bT(["aliceblue","antiquewhite","aqua","aquamarine","azure","beige","bisque","black","blanchedalmond","blue","blueviolet","brown","burlywood","cadetblue","chartreuse","chocolate","coral","cornflowerblue","cornsilk","crimson","cyan","darkblue","darkcyan","darkgoldenrod","darkgray","darkgreen","darkkhaki","darkmagenta","darkolivegreen","darkorange","darkorchid","darkred","darksalmon","darkseagreen","darkslateblue","darkslategray","darkturquoise","darkviolet","deeppink","deepskyblue","dimgray","dodgerblue","firebrick","floralwhite","forestgreen","fuchsia","gainsboro","ghostwhite","gold","goldenrod","gray","green","greenyellow","honeydew","hotpink","indianred","indigo","ivory","khaki","lavender","lavenderblush","lawngreen","lemonchiffon","lightblue","lightcoral","lightcyan","lightgoldenrodyellow","lightgreen","lightpink","lightsalmon","lightseagreen","lightskyblue","lightslategray","lightsteelblue","lightyellow","lime","limegreen","linen","magenta","maroon","mediumaquamarine","mediumblue","mediumorchid","mediumpurple","mediumseagreen","mediumslateblue","mediumspringgreen","mediumturquoise","mediumvioletred","midnightblue","mintcream","mistyrose","moccasin","navajowhite","navy","oldlace","olive","olivedrab","orange","orangered","orchid","palegoldenrod","palegreen","paleturquoise","palevioletred","papayawhip","peachpuff","peru","pink","plum","powderblue","purple","red","rosybrown","royalblue","saddlebrown","salmon","sandybrown","seagreen","seashell","sienna","silver","skyblue","slateblue","slategray","snow","springgreen","steelblue","tan","teal","thistle","tomato","turquoise","violet","wheat","white","whitesmoke","yellow","yellowgreen","activeborder","activecaption","appworkspace","background","buttonface","buttonhighlight","buttonshadow","buttontext","captiontext","graytext","highlight","highlighttext","inactiveborder","inactivecaption","inactivecaptiontext","infobackground","infotext","menu","menutext","scrollbar","threeddarkshadow","threedface","threedhighlight","threedlightshadow","threedshadow","window","windowframe","windowtext"],true),L,ab,S={"%":true,cm:true,em:true,ex:true,"in":true,mm:true,pc:true,pt:true,px:true},Q,cb,e={b:"\b",t:"\t",n:"\n",f:"\f",r:"\r",'"':'"',"/":"/","\\":"\\"},v=bT(["alert","confirm","console","Debug","opera","prompt","WSH"],false),aO,b4={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r","'":"\\'",'"':'\\"',"/":"\\/","\\":"\\\\"},U,bq=["closure","exception","global","label","outer","undef","unused","var"],bF,bk,a1,br={a:{},abbr:{},acronym:{},address:{},applet:{},area:{empty:true,parent:" map "},article:{},aside:{},audio:{},b:{},base:{empty:true,parent:" head "},bdo:{},big:{},blockquote:{},body:{parent:" html noframes "},br:{empty:true},button:{},canvas:{parent:" body p div th td "},caption:{parent:" table "},center:{},cite:{},code:{},col:{empty:true,parent:" table colgroup "},colgroup:{parent:" table "},command:{parent:" menu "},datalist:{},dd:{parent:" dl "},del:{},details:{},dialog:{},dfn:{},dir:{},div:{},dl:{},dt:{parent:" dl "},em:{},embed:{},fieldset:{},figure:{},font:{},footer:{},form:{},frame:{empty:true,parent:" frameset "},frameset:{parent:" html frameset "},h1:{},h2:{},h3:{},h4:{},h5:{},h6:{},head:{parent:" html "},header:{},hgroup:{},hr:{empty:true},"hta:application":{empty:true,parent:" head "},html:{parent:"*"},i:{},iframe:{},img:{empty:true},input:{empty:true},ins:{},kbd:{},keygen:{},label:{},legend:{parent:" details fieldset figure "},li:{parent:" dir menu ol ul "},link:{empty:true,parent:" head "},map:{},mark:{},menu:{},meta:{empty:true,parent:" head noframes noscript "},meter:{},nav:{},noframes:{parent:" html body "},noscript:{parent:" body head noframes "},object:{},ol:{},optgroup:{parent:" select "},option:{parent:" optgroup select "},output:{},p:{},param:{empty:true,parent:" applet object "},pre:{},progress:{},q:{},rp:{},rt:{},ruby:{},samp:{},script:{empty:true,parent:" body div frame head iframe p pre span "},section:{},select:{},small:{},span:{},source:{},strong:{},style:{parent:" head ",empty:true},sub:{},sup:{},table:{},tbody:{parent:" table "},td:{parent:" tr "},textarea:{},tfoot:{parent:" table "},th:{parent:" tr "},thead:{parent:" table "},time:{},title:{parent:" head "},tr:{parent:" table tbody thead tfoot "},tt:{},u:{},ul:{},"var":{},video:{}},u,aU,j,bJ,bY,aK,bC,ag,b9=bT(["Buffer","clearInterval","clearTimeout","console","exports","global","module","process","querystring","require","setInterval","setTimeout","__dirname","__filename"],false),aW,y=bT(["indexOf","lastIndexOf","search"],true),I,az,b8,q,bS,aa,z=bT(["g","i","m"],true),C=function C(){return this},bp=bT(["defineClass","deserialize","gc","help","load","loadClass","print","quit","readFile","readUrl","runCommand","seal","serialize","spawn","sync","toint32","version"],false),B,bg=bT([";",'"',"'",")"],true),b6,d,bv=bT(["Array","Boolean","Date","decodeURI","decodeURIComponent","encodeURI","encodeURIComponent","Error","eval","EvalError","Function","isFinite","isNaN","JSON","Math","Number","Object","parseInt","parseFloat","RangeError","ReferenceError","RegExp","String","SyntaxError","TypeError","URIError"],false),by,r={},bH,ay,V,a4,g,bB=bT(["alert","animator","appleScript","beep","bytesToUIString","Canvas","chooseColor","chooseFile","chooseFolder","closeWidget","COM","convertPathToHFS","convertPathToPlatform","CustomAnimation","escape","FadeAnimation","filesystem","Flash","focusWidget","form","FormField","Frame","HotKey","Image","include","isApplicationRunning","iTunes","konfabulatorVersion","log","md5","MenuItem","MoveAnimation","openURL","play","Point","popupMenu","preferenceGroups","preferences","print","prompt","random","Rectangle","reloadWidget","ResizeAnimation","resolvePath","resumeUpdates","RotateAnimation","runCommand","runCommandInBg","saveAs","savePreferences","screen","ScrollBar","showWidgetPreferences","sleep","speak","Style","suppressUpdates","system","tellWidget","Text","TextArea","Timer","unescape","updateNow","URL","Web","widget","Window","XMLDOM","XMLHttpRequest","yahooCheckLogin","yahooLogin","yahooLogout"],true),aS=bT(["ActiveXObject","CScript","Debug","Enumerator","System","VBArray","WScript","WSH"],false),bV,R,bI=/@cc|<\/?|script|\]\s*\]|<\s*!|&lt/i,O=/\r\n?|\n/,ba=/[\u0000-\u001f\u007f-\u009f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/,aT=/[\[\]\/\\"'*<>.&:(){}+=#]/,T=/^\s*(['"=>\/&#]|<(?:\/|\!(?:--)?)?|[a-zA-Z][a-zA-Z0-9_\-:]*|[0-9]+|--)/,D=/^([a-zA-Z_$][a-zA-Z0-9_$]*)$/,n=/^(?:javascript|jscript|ecmascript|vbscript|mocha|livescript)\s*:/i,b3=/\*\/|\/\*/,bw=/[\u0000-\u001f'\\\u007f-\u009f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,bi=/[>&]|<[\/!]?|--/,aM=/[^a-zA-Z0-9+\-_\/. ]/,ar=/^\s*([{}:#%.=,>+\[\]@()"';]|[*$\^~]=|[a-zA-Z_][a-zA-Z0-9_\-]*|[0-9]+|<\/|\/\*)/,bG=/^\s*([@#!"'};:\-%.=,+\[\]()*_]|[a-zA-Z][a-zA-Z0-9._\-]*|\/\*?|\d+(?:\.\d+)?|<\/)/,af=/^\s*([(){}\[\]\?.,:;'"~#@`]|={1,3}|\/(\*(jslint|properties|property|members?|globals?)?|=|\/)?|\*[\/=]?|\+(?:=|\++)?|-(?:=|-+)?|[\^%]=?|&[&=]?|\|[|=]?|>{1,3}=?|<(?:[\/=!]|\!(\[|--)?|<=?)?|\!={0,2}|[a-zA-Z_$][a-zA-Z0-9_$]*|[0-9]+(?:[xX][0-9a-fA-F]+|\.[0-9]*)?(?:[eE][+\-]?[0-9]+)?)/,K=/&|\+|\u00AD|\.\.|\/\*|%[^;]|base64|url|expression|data|mailto|script/i,aD={outer:T,html:T,style:ar,styleproperty:bG};function bA(){}if(typeof Array.prototype.filter!=="function"){Array.prototype.filter=function(cf){var ax,cd=this.length,F=[],ce;for(ax=0;ax<cd;ax+=1){try{ce=this[ax];if(cf(ce)){F.push(ce)}}catch(cg){}}return F}}if(typeof Array.prototype.forEach!=="function"){Array.prototype.forEach=function(cd){var F,ax=this.length;for(F=0;F<ax;F+=1){try{cd(this[F])}catch(ce){}}}}if(typeof Array.isArray!=="function"){Array.isArray=function(F){return Object.prototype.toString.apply(F)==="[object Array]"}}if(!Object.prototype.hasOwnProperty.call(Object,"create")){Object.create=function(F){bA.prototype=F;return new bA()}}if(typeof Object.keys!=="function"){Object.keys=function(ax){var cd=[],F;for(F in ax){if(Object.prototype.hasOwnProperty.call(ax,F)){cd.push(F)}}return cd}}if(typeof String.prototype.entityify!=="function"){String.prototype.entityify=function(){return this.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;")}}if(typeof String.prototype.isAlpha!=="function"){String.prototype.isAlpha=function(){return(this>="a"&&this<="z\uffff")||(this>="A"&&this<="Z\uffff")}}if(typeof String.prototype.isDigit!=="function"){String.prototype.isDigit=function(){return(this>="0"&&this<="9")}}if(typeof String.prototype.supplant!=="function"){String.prototype.supplant=function(F){return this.replace(/\{([^{}]*)\}/g,function(cd,ax){var ce=F[ax];return typeof ce==="string"||typeof ce==="number"?ce:cd})}}function bm(F){return b4[F]||"\\u"+("0000"+F.charCodeAt().toString(16)).slice(-4)}function Z(F){Object.keys(F).forEach(function(ax){b8[ax]=F[ax]})}function bD(){if(!az.safe){if(az.rhino){Z(bp);az.rhino=false}if(az.devel){Z(v);az.devel=false}if(az.browser){Z(aR);az.browser=false}if(az.windows){Z(aS);az.windows=false}if(az.node){Z(b9);az.node=false;aW=true}if(az.widget){Z(bB);az.widget=false}}}function ac(F){if(!F){F=I}return F.number||F.string}function p(ax,F,cd){throw {name:"JSLintError",line:F,character:cd,message:A.scanned_a_b.supplant({a:ax,b:Math.floor((F/bC.length)*100)})}}function bP(ci,ch,cg,ce,cd,ax){var F,cj,cf;ch=ch||I;cj=ch.line||0;F=ch.from||0;cf={id:"(error)",raw:A[ci]||ci,evidence:bC[cj-1]||"",line:cj,character:F,a:cg||(ch.id==="(number)"?String(ch.number):ch.string),b:ce,c:cd,d:ax};cf.reason=cf.raw.supplant(cf);JSLINT.errors.push(cf);if(az.passfail){p(A.stopping,cj,F)}g+=1;if(g>=az.maxerr){p(A.too_many,cj,F)}return cf}function aI(ce,cd,cf,ax,F,ch,cg){return bP(ce,{line:cd,from:cf},ax,F,ch,cg)}function aQ(ce,ch,ax,F,cg,cf){var cd=bP(ce,ch,ax,F,cg,cf);p(A.stopping,cd.line,cd.character)}function bl(ce,cd,cf,ax,F,ch,cg){return aQ(ce,{line:cd,from:cf},ax,F,ch,cg)}function b1(F){if(!az.white&&I.from!==F){bP("expected_a_at_b_c",I,"",F,I.from)}}function al(ax,F,cd){if(ax[F]!==cd){bP("expected_a_b",ax,cd,ax[F]);return true}return false}aK=(function aK(){var ch,cj,cl,F,co,ck,cn;function cm(){var cp;if(co>=bC.length){return false}ch=1;cn=bC[co];co+=1;cp=cn.search(/ \t/);if(cp>=0){aI("mixed",co,cp+1)}cn=cn.replace(/\t/g,bH);cp=cn.search(ba);if(cp>=0){aI("unsafe",co,cp)}if(az.maxlen&&az.maxlen<cn.length){aI("too_long",co,cn.length)}return true}function cd(cq,cr){var cs,cp;if(cq==="(string)"||cq==="(range)"){if(n.test(cr)){aI("url",co,cl)}}cp=Object.create(r[(cq==="(punctuator)"||(cq==="(identifier)"&&Object.prototype.hasOwnProperty.call(r,cr))?cr:cq)]||r["(error)"]);if(cq==="(identifier)"){cp.identifier=true;if(cr==="__iterator__"||cr==="__proto__"){bl("reserved_a",co,cl,cr)}else{if(!az.nomen&&(cr.charAt(0)==="_"||cr.charAt(cr.length-1)==="_")){aI("dangling_a",co,cl,cr)}}}if(cq==="(number)"){cp.number=+cr}else{if(cr!==undefined){cp.string=String(cr)}}cp.line=co;cp.from=cl;cp.thru=ch;cs=cp.id;q=cs&&(("(,=:[!&|?{};".indexOf(cs.charAt(cs.length-1))>=0)||cs==="return"||cs==="case");return cp}function ce(cp){var cq=cp.exec(cn),cr;if(cq){F=cq[0].length;cr=cq[1];cj=cr.charAt(0);cn=cn.slice(F);cl=ch+F-cr.length;ch+=F;return cr}}function cg(cq){var cu,ct=0,cs="",cp;function cr(cw){var cv=parseInt(cn.substr(ct+1,cw),16);ct+=cw;if(cv>=32&&cv<=126&&cv!==34&&cv!==92&&cv!==39){aI("unexpected_a",co,ch,"\\")}ch+=cw;cu=String.fromCharCode(cv)}if(bY&&cq!=='"'){aI("expected_a",co,ch,'"')}if(R===cq||(bV==="scriptstring"&&!R)){return cd("(punctuator)",cq)}for(;;){while(ct>=cn.length){ct=0;if(bV!=="html"||!cm()){bl("unclosed",co,cl)}}cu=cn.charAt(ct);if(cu===cq){ch+=1;cn=cn.slice(ct+1);cp=cd("(string)",cs);cp.quote=cq;return cp}if(cu<" "){if(cu==="\n"||cu==="\r"){break}aI("control_a",co,ch+ct,cn.slice(0,ct))}else{if(cu===R){aI("bad_html",co,ch+ct)}else{if(cu==="<"){if(az.safe&&bV==="html"){aI("adsafe_a",co,ch+ct,cu)}else{if(cn.charAt(ct+1)==="/"&&(bV||az.safe)){aI("expected_a_b",co,ch,"<\\/","</")}else{if(cn.charAt(ct+1)==="!"&&(bV||az.safe)){aI("unexpected_a",co,ch,"<!")}}}}else{if(cu==="\\"){if(bV==="html"){if(az.safe){aI("adsafe_a",co,ch+ct,cu)}}else{if(bV==="styleproperty"){ct+=1;ch+=1;cu=cn.charAt(ct);if(cu!==cq){aI("unexpected_a",co,ch,"\\")}}else{ct+=1;ch+=1;cu=cn.charAt(ct);switch(cu){case"":if(!az.es5){aI("es5",co,ch)}cm();ct=-1;break;case R:aI("bad_html",co,ch+ct);break;case"'":if(bY){aI("unexpected_a",co,ch,"\\'")}break;case"u":cr(4);break;case"v":if(bY){aI("unexpected_a",co,ch,"\\v")}cu="\v";break;case"x":if(bY){aI("unexpected_a",co,ch,"\\x")}cr(2);break;default:if(typeof e[cu]!=="string"){aI(cu>="0"&&cu<="7"?"octal_a":"unexpected_a",co,ch,"\\"+cu)}else{cu=e[cu]}}}}}}}}cs+=cu;ch+=1;ct+=1}}function ax(cp){var cq;if(bV!=="style"&&bV!=="styleproperty"&&cn.charAt(0).isAlpha()){aI("expected_space_a_b",co,ch,cj,cn.charAt(0))}if(cj==="0"){cq=cp.charAt(1);if(cq.isDigit()){if(ay.id!=="."&&bV!=="styleproperty"){aI("unexpected_a",co,ch,cp)}}else{if(bY&&(cq==="x"||cq==="X")){aI("unexpected_a",co,ch,"0x")}}}if(cp.slice(cp.length-1)==="."){aI("trailing_decimal_a",co,ch,cp)}if(bV!=="style"){cq=+cp;if(!isFinite(cq)){aI("bad_number",co,ch,cp)}cp=cq}return cd("(number)",cp)}function cf(cp){if(o||b6||(bV&&bV!=="script"&&bV!=="style"&&bV!=="styleproperty")){aI("unexpected_comment",co,ch)}else{if(bV==="script"&&/<\//i.test(cn)){aI("unexpected_a",co,ch,"</")}else{if(az.safe&&bI.test(cp)){aI("dangerous_comment",co,ch)}}}}function ci(){var cz,cy,cr=0,cv=0,cw="",cu,ct,cs=0,cx,cq,cp,cA;for(;;){cz=true;cj=cn.charAt(cs);cs+=1;switch(cj){case"":bl("unclosed_regexp",co,cl);return;case"/":if(cv>0){aI("unescaped_a",co,cl+cs,"/")}cj=cn.slice(0,cs-1);cq=Object.create(z);for(;;){ct=cn.charAt(cs);if(cq[ct]!==true){break}cq[ct]=false;cs+=1;cw+=ct}if(cn.charAt(cs).isAlpha()){bl("unexpected_a",co,cl,cn.charAt(cs))}ch+=cs;cn=cn.slice(cs);cp=cn.charAt(0);if(cp==="/"||cp==="*"){bl("confusing_regexp",co,cl)}cA=cd("(regexp)",cj);cA.flag=cw;return cA;case"\\":cj=cn.charAt(cs);if(cj<" "){aI("control_a",co,cl+cs,String(cj))}else{if(cj==="<"){aI(A.unexpected_a,co,cl+cs,"\\")}}cs+=1;break;case"(":cv+=1;cz=false;if(cn.charAt(cs)==="?"){cs+=1;switch(cn.charAt(cs)){case":":case"=":case"!":cs+=1;break;default:aI(A.expected_a_b,co,cl+cs,":",cn.charAt(cs))}}else{cr+=1}break;case"|":cz=false;break;case")":if(cv===0){aI("unescaped_a",co,cl+cs,")")}else{cv-=1}break;case" ":ck=1;while(cn.charAt(cs)===" "){cs+=1;ck+=1}if(ck>1){aI("use_braces",co,cl+cs,ck)}break;case"[":cj=cn.charAt(cs);if(cj==="^"){cs+=1;if(!az.regexp){aI("insecure_a",co,cl+cs,cj)}else{if(cn.charAt(cs)==="]"){bl("unescaped_a",co,cl+cs,"^")}}}cy=false;if(cj==="]"){aI("empty_class",co,cl+cs-1);cy=true}klass:do{cj=cn.charAt(cs);cs+=1;switch(cj){case"[":case"^":aI("unescaped_a",co,cl+cs,cj);cy=true;break;case"-":if(cy){cy=false}else{aI("unescaped_a",co,cl+cs,"-");cy=true}break;case"]":if(!cy){aI("unescaped_a",co,cl+cs-1,"-")}break klass;case"\\":cj=cn.charAt(cs);if(cj<" "){aI(A.control_a,co,cl+cs,String(cj))}else{if(cj==="<"){aI(A.unexpected_a,co,cl+cs,"\\")}}cs+=1;cy=true;break;case"/":aI("unescaped_a",co,cl+cs-1,"/");cy=true;break;case"<":if(bV==="script"){cj=cn.charAt(cs);if(cj==="!"||cj==="/"){aI(A.html_confusion_a,co,cl+cs,cj)}}cy=true;break;default:cy=true}}while(cj);break;case".":if(!az.regexp){aI("insecure_a",co,cl+cs,cj)}break;case"]":case"?":case"{":case"}":case"+":case"*":aI("unescaped_a",co,cl+cs,cj);break;case"<":if(bV==="script"){cj=cn.charAt(cs);if(cj==="!"||cj==="/"){aI(A.html_confusion_a,co,cl+cs,cj)}}break}if(cz){switch(cn.charAt(cs)){case"?":case"+":case"*":cs+=1;if(cn.charAt(cs)==="?"){cs+=1}break;case"{":cs+=1;cj=cn.charAt(cs);if(cj<"0"||cj>"9"){aI(A.expected_number_a,co,cl+cs,cj)}cs+=1;cx=+cj;for(;;){cj=cn.charAt(cs);if(cj<"0"||cj>"9"){break}cs+=1;cx=+cj+(cx*10)}cu=cx;if(cj===","){cs+=1;cu=Infinity;cj=cn.charAt(cs);if(cj>="0"&&cj<="9"){cs+=1;cu=+cj;for(;;){cj=cn.charAt(cs);if(cj<"0"||cj>"9"){break}cs+=1;cu=+cj+(cu*10)}}}if(cn.charAt(cs)!=="}"){aI(A.expected_a_b,co,cl+cs,"}",cj)}else{cs+=1}if(cn.charAt(cs)==="?"){cs+=1}if(cx>cu){aI(A.not_greater,co,cl+cs,cx,cu)}break}}}cj=cn.slice(0,cs-1);ch+=cs;cn=cn.slice(cs);return cd("(regexp)",cj)}return{init:function(cp){if(typeof cp==="string"){bC=cp.split(O)}else{bC=cp}co=0;cm();cl=1},range:function(cq,cp){var cs,cr="";cl=ch;if(cn.charAt(0)!==cq){bl("expected_a_b",co,ch,cq,cn.charAt(0))}for(;;){cn=cn.slice(1);ch+=1;cs=cn.charAt(0);switch(cs){case"":bl("missing_a",co,ch,cs);break;case cp:cn=cn.slice(1);ch+=1;return cd("(range)",cr);case R:case"\\":aI("unexpected_a",co,ch,cs);break}cr+=cs}},token:function(){var cr,cp,cq;for(;;){while(!cn){if(!cm()){return cd("(end)")}}while(bV==="outer"){cp=cn.search(bi);if(cp===0){break}else{if(cp>0){ch+=1;cn=cn.slice(cp);break}else{if(!cm()){return cd("(end)","")}}}}cq=ce(aD[bV]||af);if(!cq){if(cn){if(cn.charAt(0)===" "){if(!az.white){aI("unexpected_a",co,ch,"(space)")}ch+=1;cn=""}else{bl("unexpected_a",co,ch,cn.charAt(0))}}}else{cr=cq.charAt(0);if(cr.isAlpha()||cr==="_"||cr==="$"){return cd("(identifier)",cq)}if(cr.isDigit()){return ax(cq)}switch(cq){case'"':case"'":return cg(cq);case"//":cf(cn);cn="";break;case"/*":for(;;){cp=cn.search(b3);if(cp>=0){break}cf(cn);if(!cm()){bl("unclosed_comment",co,ch)}}cf(cn.slice(0,cp));ch+=cp+2;if(cn.charAt(cp)==="/"){bl("nested_comment",co,ch)}cn=cn.slice(cp+2);break;case"":break;case"/":if(ay.id==="/="){bl(A.slash_equal,co,cl)}return q?ci():cd("(punctuator)",cq);case"<!--":F=co;for(;;){cp=cn.indexOf("--");if(cp>=0){break}cp=cn.indexOf("<!");if(cp>=0){bl("nested_comment",co,ch+cp)}if(!cm()){bl("unclosed_comment",F,cr)}}F=cn.indexOf("<!");if(F>=0&&F<cp){bl("nested_comment",co,ch+F)}ch+=cp;if(cn.charAt(cp+2)!==">"){bl("expected_a",co,ch,"-->")}ch+=3;cn=cn.slice(cp+3);break;case"#":if(bV==="html"||bV==="styleproperty"){for(;;){cr=cn.charAt(0);if((cr<"0"||cr>"9")&&(cr<"a"||cr>"f")&&(cr<"A"||cr>"F")){break}ch+=1;cn=cn.slice(1);cq+=cr}if(cq.length!==4&&cq.length!==7){aI("bad_color_a",co,cl+F,cq)}return cd("(color)",cq)}return cd("(punctuator)",cq);default:if(bV==="outer"&&cr==="&"){ch+=1;cn=cn.slice(1);for(;;){cr=cn.charAt(0);ch+=1;cn=cn.slice(1);if(cr===";"){break}if(!((cr>="0"&&cr<="9")||(cr>="a"&&cr<="z")||cr==="#")){bl("bad_entity",co,cl+F,ch)}}break}return cd("(punctuator)",cq)}}}}}}());function m(ax,cd,F){F=F||ax.string;if(U===bk){if(az.safe){bP("adsafe_a",ax,F)}if(typeof bk[F]!=="string"){ax.writeable=typeof b8[F]==="boolean"?b8[F]:true;ax.funct=U;a1[F]=ax}if(cd==="becoming"){cd="var"}}else{if(typeof U[F]==="string"){if(U[F]==="undef"){if(!az.undef){bP("used_before_a",ax,F)}cd="var"}else{bP("already_defined",ax,F)}}else{ax.funct=U;ax.writeable=true;B[F]=ax}}U[F]=cd}function av(cd){var F,ax=0;cd=cd||0;while(ax<=cd){F=ag[ax];if(!F){F=ag[ax]=aK.token()}ax+=1}return F}function f(cd,F){if(j){if(a4&&I.line!==ay.line){if((a4!==j||!I.edge)&&I.from===j.at-(I.edge?az.indent:0)){var ax=j;for(;;){ax.at-=az.indent;if(ax===a4){break}ax=ax.was}ax.open=false}a4=null}if(I.id==="?"&&j.mode===":"&&ay.line!==I.line){j.at-=az.indent}if(j.open){if(I.edge){if(I.edge==="label"){b1(1)}else{if(I.edge==="case"||j.mode==="statement"){b1(j.at-az.indent)}else{if(j.mode!=="array"||I.line!==ay.line){b1(j.at)}}}}else{if(I.line!==ay.line){if(I.from<j.at+(j.mode==="expression"?0:az.indent)){b1(j.at+az.indent)}j.wrap=true}}}else{if(I.line!==ay.line){if(I.edge){b1(j.at)}else{j.wrap=true;if(j.mode==="statement"||j.mode==="var"){b1(j.at+az.indent)}else{if(I.from<j.at+(j.mode==="expression"?0:az.indent)){b1(j.at+az.indent)}}}}}}switch(ay.id){case"(number)":if(I.id==="."){bP("trailing_decimal_a")}break;case"-":if(I.id==="-"||I.id==="--"){bP("confusing_a")}break;case"+":if(I.id==="+"||I.id==="++"){bP("confusing_a")}break}if(ay.id==="(string)"||ay.identifier){a9=ay.string}if(cd&&I.id!==cd){if(F){bP("expected_a_b_from_c_d",I,cd,F.id,F.line,ac())}else{if(!I.identifier||I.string!==cd){bP("expected_a_b",I,cd,ac())}}}bS=ay;ay=I;I=ag.shift()||aK.token()}function J(F){if(I.identifier&&I.string===F){f()}else{bP("expected_a_b",I,F,ac())}}function aX(){if(az.adsafe){az.safe=true}if(az.safe){az.browser=az["continue"]=az.css=az.debug=az.devel=az.evil=az.forin=az.newcap=az.nomen=az.on=az.rhino=az.sloppy=az.sub=az.undef=az.widget=az.windows=false;delete b8.Array;delete b8.Date;delete b8.Function;delete b8.Object;delete b8["eval"];Z({ADSAFE:false,lib:false})}}function bf(){var F,ax;for(;;){if(I.id!=="(string)"&&!I.identifier){return}F=I.string;f();ax=false;if(I.id===":"){f(":");switch(I.id){case"true":ax=b8[F]!==false;f("true");break;case"false":f("false");break;default:aQ("unexpected_a")}}b8[F]=ax;if(I.id!==","){return}f(",")}}function aF(){var F,ax;while(I.id==="(string)"||I.identifier){F=I.string;if(!l[F]){aQ("unexpected_a")}f();if(I.id!==":"){aQ("expected_a_b",I,":",ac())}f(":");if(typeof l[F]==="number"){ax=I.number;if(ax>l[F]||ax<=0||Math.floor(ax)!==ax){aQ("expected_small_a")}az[F]=ax}else{if(I.id==="true"){az[F]=true}else{if(I.id==="false"){az[F]=false}else{aQ("unexpected_a")}}}f();if(I.id===","){f(",")}}bD()}function cc(){var F;az.properties=true;for(;;){if(I.id!=="(string)"&&!I.identifier){return}F=I.string;f();if(I.id===":"){for(;;){f();if(I.id!=="(string)"&&!I.identifier){break}}}aa[F]=0;if(I.id!==","){return}f(",")}}aO=function aO(){var cd=this.id,ax=o,F=j;o=true;j=null;if(I.line===ay.line&&I.from===ay.thru){bP("missing_space_a_b",I,ac(ay),ac())}if(ag.length>0){bP("unexpected_a",this)}switch(cd){case"/*properties":case"/*property":case"/*members":case"/*member":cc();break;case"/*jslint":if(az.safe){bP("adsafe_a",this)}aF();break;case"/*globals":case"/*global":if(az.safe){bP("adsafe_a",this)}bf();break;default:aQ("unexpected_a",this)}o=ax;f("*/");j=F};function aq(F){I.edge=j?j.open&&(F||"edge"):""}function bR(ax){var F;if(typeof ax==="number"){j={at:+ax,open:true,was:j}}else{if(!j){j={at:1,mode:"statement",open:true}}else{if(ax==="statement"){j={at:j.at,open:true,was:j}}else{F=ax==="var"||I.line!==ay.line;j={at:(F||ax==="control"?j.at+az.indent:j.at)+(j.wrap?az.indent:0),mode:ax,open:F,was:j};if(ax==="var"&&F){a4=j}}}}}function bs(ax,F){if(ax){if(j&&j.open){j.at-=az.indent;aq()}f(ax,F)}if(j){j=j.was}}function bb(ax,F){ax=ax||ay;F=F||I;if(F.id!=="(end)"&&!az.white&&(ay.line!==F.line||ay.thru+1!==F.from)){bP("expected_space_a_b",F,ac(ay),ac(F))}}function bt(ax,F){ax=ax||ay;F=F||I;if(F.id!=="(end)"&&(ax.line!==F.line||(!az.white&&ax.thru+1!==F.from))){bP("expected_space_a_b",F,ac(ax),ac(F))}}function P(ax,F){ax=ax||ay;F=F||I;if((!az.white||bV==="styleproperty"||bV==="style")&&ax.thru!==F.from&&ax.line===F.line){bP("unexpected_space_a_b",F,ac(ax),ac(F))}}function b2(ax,F){ax=ax||ay;F=F||I;if(F.id!=="(end)"&&(ax.line!==F.line||(!az.white&&ax.thru!==F.from))){bP("unexpected_space_a_b",F,ac(ax),ac(F))}}function G(ax,F){if(!az.white){ax=ax||ay;F=F||I;if(ax.thru===F.from&&ax.line===F.line){bP("missing_space_a_b",F,ac(ax),ac(F))}}}function aN(){if(I.id!==","){aI("expected_a_b",ay.line,ay.thru,",",ac())}else{if(!az.white){b2()}f(",");G()}}function ak(){if(I.id!==";"){aI("expected_a_b",ay.line,ay.thru,";",ac())}else{if(!az.white){b2()}f(";");if(bg[I.id]!==true){G()}}}function w(){if(I.string==="use strict"){if(by){bP("unnecessary_use")}aq();f();ak();by=true;az.newcap=false;az.undef=false;return true}return false}function a6(ax,F){if(ax===F){return true}if(Array.isArray(ax)){if(Array.isArray(F)&&ax.length===F.length){var cd;for(cd=0;cd<ax.length;cd+=1){if(!a6(ax[cd],F[cd])){return false}}return true}return false}if(Array.isArray(F)){return false}if(ax.id==="(number)"&&F.id==="(number)"){return ax.number===F.number}if(ax.arity===F.arity&&ax.string===F.string){switch(ax.arity){case"prefix":case"suffix":case undefined:return ax.id===F.id&&a6(ax.first,F.first);case"infix":return a6(ax.first,F.first)&&a6(ax.second,F.second);case"ternary":return a6(ax.first,F.first)&&a6(ax.second,F.second)&&a6(ax.third,F.third);case"function":case"regexp":return false;default:return true}}else{if(ax.id==="."&&F.id==="["&&F.arity==="infix"){return ax.second.string===F.second.string&&F.second.id==="(string)"}if(ax.id==="["&&ax.arity==="infix"&&F.id==="."){return ax.second.string===F.second.string&&ax.second.id==="(string)"}}return false}function a(F,ax){var cd;if(I.id==="(end)"){aQ("unexpected_a",ay,I.id)}f();if(az.safe&&B[ay.string]&&B[ay.string]===a1[ay.string]&&(I.id!=="("&&I.id!==".")){bP("adsafe_a",ay)}if(ax){a9="anonymous";U["(verb)"]=ay.string}if(ax===true&&ay.fud){cd=ay.fud()}else{if(ay.nud){cd=ay.nud()}else{if(I.id==="(number)"&&ay.id==="."){bP("leading_decimal_a",ay,ac());f();return ay}aQ("expected_identifier_a",ay,ay.id)}while(F<I.lbp){f();if(ay.led){cd=ay.led(cd)}else{aQ("expected_operator_a",ay,ay.id)}}}return cd}function ca(ax,cd){var F=r[ax];if(!F||typeof F!=="object"){r[ax]=F={id:ax,lbp:cd||0,string:ax}}return F}function bE(F){F.postscript=true;return F}function aV(ax){var F=ca(ax,0);F.from=1;F.thru=1;F.line=0;F.edge="edge";ax.string=ax;return bE(F)}function bo(ax,cd){var F=ca(ax);F.identifier=F.reserved=true;F.fud=cd;return F}function bQ(ax,cd){var F=bo(ax,cd);F.labeled=true}function bN(ax,cd){var F=bo(ax,cd);F.disrupt=true}function aZ(F){var ax=F.id.charAt(0);if((ax>="a"&&ax<="z")||(ax>="A"&&ax<="Z")){F.identifier=F.reserved=true}return F}function bL(ax,cd){var F=ca(ax,150);aZ(F);F.nud=typeof cd==="function"?cd:function(){if(ax==="typeof"){bb()}else{b2()}this.first=a(150);this.arity="prefix";if(this.id==="++"||this.id==="--"){if(!az.plusplus){bP("unexpected_a",this)}else{if((!this.first.identifier||this.first.reserved)&&this.first.id!=="."&&this.first.id!=="["){bP("bad_operand",this)}}}return this};return F}function H(ce,cd,ax){var F=ca(ce);F.arity=cd;if(ax){F.nud=ax}return F}function h(ax,cd){var F=ca(ax);F.identifier=F.reserved=true;if(typeof cd==="function"){F.nud=cd}return F}function bu(ax){var F=h(ax);F.string=ax;F.nud=C;return F}function X(ax,F){return h(ax,function(){if(typeof F==="function"){F(this)}return this})}function aH(cd,cf,ce,ax){var F=ca(cd,cf);aZ(F);F.led=function(cg){this.arity="infix";if(!ax){G(bS,ay);G()}if(!az.bitwise&&this.bitwise){bP("unexpected_a",this)}if(typeof ce==="function"){return ce(cg,this)}this.first=cg;this.second=a(cf);return this};return F}function a2(ax,F){if(ax.assign){bP(F||A.conditional_assignment,ax)}return ax}function Y(ax,F){switch(ax.id){case"[":case"-":if(ax.arity!=="infix"){bP(F||A.weird_condition,ax)}break;case"false":case"function":case"Infinity":case"NaN":case"null":case"true":case"undefined":case"void":case"(number)":case"(regexp)":case"(string)":case"{":bP(F||A.weird_condition,ax);break;case"(":if(ax.first.id==="."&&y[ax.first.second.string]===true){bP(F||A.weird_condition,ax)}break}return ax}function aE(F){switch(F.arity){case"prefix":switch(F.id){case"{":case"[":bP("unexpected_a",F);break;case"!":bP("confusing_a",F);break}break;case"function":case"regexp":bP("unexpected_a",F);break;default:if(F.id==="NaN"){bP("isNaN",F)}}return F}function bX(ax,F){return aH(ax,100,function(cf,ce){aE(cf);if(F&&!az.eqeq){bP("expected_a_b",ce,F,ce.id)}var cd=a(100);if(a6(cf,cd)||((cf.id==="(string)"||cf.id==="(number)")&&(cd.id==="(string)"||cd.id==="(number)"))){bP("weird_relation",ce)}ce.first=cf;ce.second=aE(cd);return ce})}function bc(ax,cd){var F=aH(ax,20,function(cg,cf){var ce;cf.first=cg;if(cg.identifier){if(B[cg.string]){if(B[cg.string].writeable===false){bP("read_only",cg)}}else{aQ("read_only")}if(U["(params)"]){U["(params)"].forEach(function(ch){if(ch.string===cg.string){ch.assign=true}})}}else{if(az.safe){ce=cg;do{if(typeof b8[ce.string]==="boolean"){bP("adsafe_a",ce)}ce=ce.first}while(ce)}}if(cg===r["function"]){bP("identifier_function",ay)}if(cg.id==="."||cg.id==="["){if(!cg.first||cg.first.string==="arguments"){bP("bad_assignment",cf)}}else{if(cg.identifier){if(!cg.reserved&&U[cg.string]==="exception"){bP("assign_exception",cg)}}else{bP("bad_assignment",cf)}}cf.second=a(19);if(cf.id==="="&&a6(cf.first,cf.second)){bP("weird_assignment",cf)}return cf});F.assign=true;if(cd){if(r[cd].bitwise){F.bitwise=true}}return F}function bZ(ax,cd){var F=aH(ax,cd,"number");F.bitwise=true;return F}function b(ax){var F=ca(ax,150);F.led=function(cd){b2(bS,ay);if(!az.plusplus){bP("unexpected_a",this)}else{if((!cd.identifier||cd.reserved)&&cd.id!=="."&&cd.id!=="["){bP("bad_operand",this)}}this.first=cd;this.arity="suffix";return this};return F}function a0(){if(I.identifier){f();if(az.safe&&ad[ay.string]){bP("adsafe_a",ay)}else{if(ay.reserved&&!az.es5){bP("expected_identifier_a_reserved",ay)}}return ay.string}}function aj(){var F=a0();if(!F){aQ(ay.id==="function"&&I.id==="("?"name_function":"expected_identifier_a")}return F}function aL(){var cd,ax=B,F;if(I.id===";"){bP("unexpected_a");ak();return}if(I.identifier&&!I.reserved&&av().id===":"){aq("label");cd=I;f();f(":");B=Object.create(ax);m(cd,"label");if(I.labeled!==true){bP("label_a_b",I,cd.string,ac())}else{if(n.test(cd.string+":")){bP("url",cd)}else{if(U===bk){aQ("unexpected_a",ay)}}}I.label=cd}if(ay.id!=="else"){aq()}bR("statement");F=a(0,true);if(F){if(F.arity==="statement"){if(F.id==="switch"||(F.block&&F.id!=="do")){G()}else{ak()}}else{if(F.id==="("){if(F.first.id==="new"){bP("bad_new")}}else{if(!F.assign&&F.id!=="delete"&&F.id!=="++"&&F.id!=="--"){bP("assignment_function_expression",ay)}}ak()}}bs();B=ax;return F}function ae(){var cd=[],ax,F;while(I.postscript!==true){if(I.id===";"){bP("unexpected_a",I);ak()}else{if(I.string==="use strict"){if((!aW&&bV!=="script")||U!==bk||cd.length>0){bP("function_strict")}w()}if(ax){bP("unreachable_a_b",I,I.string,ax.string);ax=null}F=aL();if(F){cd.push(F);if(F.disrupt){ax=F;cd.disrupt=true}}}}return cd}function b7(cd){var cg,ax=I,cf=aU,F=B,ce=by;aU=cd;B=Object.create(B);G();if(I.id==="{"){f("{");bR();if(!cd&&!w()&&!ce&&!az.sloppy&&U["(context)"]===bk){bP("missing_use_strict")}cg=ae();by=ce;bs("}",ax)}else{if(!cd){aQ("expected_a_b",I,"{",ac())}else{bP("expected_a_b",I,"{",ac());cg=[aL()];cg.disrupt=cg[0].disrupt}}U["(verb)"]=null;B=F;aU=cf;if(cd&&cg.length===0){bP("empty_block")}return cg}function bK(F){if(az.properties&&typeof aa[F]!=="number"){bP("unexpected_property_a",ay,F)}if(typeof aa[F]==="number"){aa[F]+=1}else{aa[F]=1}}r["(identifier)"]={id:"(identifier)",lbp:0,identifier:true,nud:function(){var cd=this.string,ax=B[cd],F,ce;if(typeof ax!=="object"){ce=b8[cd];if(typeof ce==="boolean"){a1[cd]=ax={string:cd,writeable:ce,funct:bk};bk[cd]="var"}else{if(!az.undef){bP("used_before_a",ay)}B[cd]=ax={string:cd,writeable:true,funct:U};U[cd]="undef"}}F=ax.funct;if(U===F){switch(U[cd]){case"becoming":bP("unexpected_a",ay);U[cd]="var";break;case"unused":U[cd]="var";break;case"unparam":U[cd]="parameter";break;case"unction":U[cd]="function";break;case"label":bP("a_label",ay,cd);break}}else{switch(U[cd]){case"closure":case"function":case"var":case"unused":bP("a_scope",ay,cd);break;case"label":bP("a_label",ay,cd);break;case"outer":case"global":break;default:switch(F[cd]){case"becoming":case"closure":case"function":case"parameter":case"unction":case"unused":case"var":F[cd]="closure";U[cd]=F===bk?"global":"outer";break;case"unparam":F[cd]="parameter";U[cd]="outer";break;case"undef":U[cd]="undef";break;case"label":bP("a_label",ay,cd);break}}}return this},led:function(){aQ("expected_operator_a")}};H("(array)","array");H("(color)","color");H("(function)","function");H("(number)","number",C);H("(object)","object");H("(string)","string",C);H("(boolean)","boolean",C);H("(range)","range");H("(regexp)","regexp",C);aV("(begin)");aV("(end)");aV("(error)");bE(ca("</"));ca("<!");ca("<!--");ca("-->");bE(ca("}"));ca(")");ca("]");bE(ca('"'));bE(ca("'"));ca(";");ca(":");ca(",");ca("#");ca("@");ca("*/");bE(h("case"));h("catch");bE(h("default"));h("else");h("finally");X("arguments",function(F){if(by&&U===bk){bP("strict",F)}else{if(az.safe){bP("adsafe_a",F)}}U["(arguments)"]=true});X("eval",function(F){if(az.safe){bP("adsafe_a",F)}});bu("false","boolean");bu("Infinity","number");bu("NaN","number");bu("null","");X("this",function(F){if(az.safe){bP("adsafe_a",F)}else{if(by&&U["(token)"].arity==="statement"&&U["(name)"].charAt(0)>"Z"){bP("strict",F)}}});bu("true","boolean");bu("undefined","");aH("?",30,function(cd,ax){bR("?");ax.first=Y(a2(cd));ax.second=a(0);G();bs();var F=I;f(":");bR(":");G();ax.third=a(10);ax.arity="ternary";if(a6(ax.second,ax.third)){bP("weird_ternary",F)}else{if(a6(ax.first,ax.second)){bP("use_or",ax)}}bs();return ax});aH("||",40,function(cd,ax){function F(ce){if(ce.id==="&&"&&!ce.paren){bP("and",ce)}return ce}ax.first=F(Y(a2(cd)));ax.second=F(a2(a(40)));if(a6(ax.first,ax.second)){bP("weird_condition",ax)}return ax});aH("&&",50,function(ax,F){F.first=Y(a2(ax));F.second=a2(a(50));if(a6(F.first,F.second)){bP("weird_condition",F)}return F});bL("void",function(){this.first=a(0);this.arity="prefix";if(az.es5){bP("expected_a_b",this,"undefined","void")}else{if(this.first.number!==0){bP("expected_a_b",this.first,"0",ac(this.first))}}return this});bZ("|",70);bZ("^",80);bZ("&",90);bX("==","===");bX("===");bX("!=","!==");bX("!==");bX("<");bX(">");bX("<=");bX(">=");bZ("<<",120);bZ(">>",120);bZ(">>>",120);aH("in",120,function(ax,F){bP("infix_in",F);F.left=ax;F.right=a(130);return F});aH("instanceof",120);aH("+",130,function(cd,ax){if(cd.id==="(number)"){if(cd.number===0){bP("unexpected_a",cd,"0")}}else{if(cd.id==="(string)"){if(cd.string===""){bP("expected_a_b",cd,"String","''")}}}var F=a(130);if(F.id==="(number)"){if(F.number===0){bP("unexpected_a",F,"0")}}else{if(F.id==="(string)"){if(F.string===""){bP("expected_a_b",F,"String","''")}}}if(cd.id===F.id){if(cd.id==="(string)"||cd.id==="(number)"){if(cd.id==="(string)"){cd.string+=F.string;if(n.test(cd.string)){bP("url",cd)}}else{cd.number+=F.number}cd.thru=F.thru;return cd}}ax.first=cd;ax.second=F;return ax});bL("+","num");bL("+++",function(){bP("confusing_a",ay);this.first=a(150);this.arity="prefix";return this});aH("+++",130,function(F){bP("confusing_a",ay);this.first=F;this.second=a(130);return this});aH("-",130,function(cd,ax){if((cd.id==="(number)"&&cd.number===0)||cd.id==="(string)"){bP("unexpected_a",cd)}var F=a(130);if((F.id==="(number)"&&F.number===0)||F.id==="(string)"){bP("unexpected_a",F)}if(cd.id===F.id&&cd.id==="(number)"){cd.number-=F.number;cd.thru=F.thru;return cd}ax.first=cd;ax.second=F;return ax});bL("-");bL("---",function(){bP("confusing_a",ay);this.first=a(150);this.arity="prefix";return this});aH("---",130,function(F){bP("confusing_a",ay);this.first=F;this.second=a(130);return this});aH("*",140,function(cd,ax){if((cd.id==="(number)"&&(cd.number===0||cd.number===1))||cd.id==="(string)"){bP("unexpected_a",cd)}var F=a(140);if((F.id==="(number)"&&(F.number===0||F.number===1))||F.id==="(string)"){bP("unexpected_a",F)}if(cd.id===F.id&&cd.id==="(number)"){cd.number*=F.number;cd.thru=F.thru;return cd}ax.first=cd;ax.second=F;return ax});aH("/",140,function(cd,ax){if((cd.id==="(number)"&&cd.number===0)||cd.id==="(string)"){bP("unexpected_a",cd)}var F=a(140);if((F.id==="(number)"&&(F.number===0||F.number===1))||F.id==="(string)"){bP("unexpected_a",F)}if(cd.id===F.id&&cd.id==="(number)"){cd.number/=F.number;cd.thru=F.thru;return cd}ax.first=cd;ax.second=F;return ax});aH("%",140,function(cd,ax){if((cd.id==="(number)"&&(cd.number===0||cd.number===1))||cd.id==="(string)"){bP("unexpected_a",cd)}var F=a(140);if((F.id==="(number)"&&F.number===0)||F.id==="(string)"){bP("unexpected_a",F)}if(cd.id===F.id&&cd.id==="(number)"){cd.number%=F.number;cd.thru=F.thru;return cd}ax.first=cd;ax.second=F;return ax});b("++");bL("++");b("--");bL("--");bL("delete",function(){bb();var F=a(0);if(!F||(F.id!=="."&&F.id!=="[")){bP("deleted")}this.first=F;return this});bL("~",function(){b2();if(!az.bitwise){bP("unexpected_a",this)}a(150);return this});bL("!",function(){b2();this.first=Y(a(150));this.arity="prefix";if(bd[this.first.id]===true||this.first.assign){bP("confusing_a",this)}return this});bL("typeof",null);bL("new",function(){bb();var ce=a(160),cd,ax,F;this.first=ce;if(ce.id!=="function"){if(ce.identifier){switch(ce.string){case"Object":bP("use_object",ay);break;case"Array":if(I.id==="("){ax=I;ax.first=this;f("(");if(I.id!==")"){cd=a(0);ax.second=[cd];if(cd.id!=="(number)"||I.id===","){bP("use_array",ax)}while(I.id===","){f(",");ax.second.push(a(0))}}else{bP("use_array",ay)}f(")",ax);return ax}bP("use_array",ay);break;case"Number":case"String":case"Boolean":case"Math":case"JSON":bP("not_a_constructor",ce);break;case"Function":if(!az.evil){bP("function_eval")}break;case"Date":case"RegExp":case"this":break;default:if(ce.id!=="function"){F=ce.string.charAt(0);if(!az.newcap&&(F<"A"||F>"Z")){bP("constructor_name_a",ay)}}}}else{if(ce.id!=="."&&ce.id!=="["&&ce.id!=="("){bP("bad_constructor",ay)}}}else{bP("weird_new",this)}if(I.id!=="("){bP("missing_a",I,"()")}return this});aH("(",160,function(cd,F){var ax;if(j&&j.mode==="expression"){P(bS,ay)}else{b2(bS,ay)}if(!cd.immed&&cd.id==="function"){bP("wrap_immediate")}ax=[];if(cd.identifier){if(cd.string.match(/^[A-Z]([A-Z0-9_$]*[a-z][A-Za-z0-9_$]*)?$/)){if(cd.string!=="Number"&&cd.string!=="String"&&cd.string!=="Boolean"&&cd.string!=="Date"){if(cd.string==="Math"||cd.string==="JSON"){bP("not_a_function",cd)}else{if(cd.string==="Object"){bP("use_object",ay)}else{if(cd.string==="Array"||!az.newcap){bP("missing_a",cd,"new")}}}}}}else{if(cd.id==="."){if(az.safe&&cd.first.string==="Math"&&cd.second==="random"){bP("adsafe_a",cd)}else{if(cd.second.string==="split"&&cd.first.id==="(string)"){bP("use_array",cd.second)}}}}bR();if(I.id!==")"){P();for(;;){aq();ax.push(a(10));if(I.id!==","){break}aN()}}P();bs(")",F);if(typeof cd==="object"){if(cd.string==="parseInt"&&ax.length===1){bP("radix",cd)}if(!az.evil){if(cd.string==="eval"||cd.string==="Function"||cd.string==="execScript"){bP("evil",cd)}else{if(ax[0]&&ax[0].id==="(string)"&&(cd.string==="setTimeout"||cd.string==="setInterval")){bP("implied_evil",cd)}}}if(!cd.identifier&&cd.id!=="."&&cd.id!=="["&&cd.id!=="("&&cd.id!=="&&"&&cd.id!=="||"&&cd.id!=="?"){bP("bad_invocation",cd)}}F.first=cd;F.second=ax;return F},true);bL("(",function(){bR("expression");P();aq();if(I.id==="function"){I.immed=true}var F=a(0);F.paren=true;P();bs(")",this);if(F.id==="function"){switch(I.id){case"(":bP("move_invocation");break;case".":case"[":bP("unexpected_a");break;default:bP("bad_wrap",this)}}return F});aH(".",170,function(cd,ax){P(bS,ay);P();var F=aj();if(typeof F==="string"){bK(F)}ax.first=cd;ax.second=ay;if(cd&&cd.string==="arguments"&&(F==="callee"||F==="caller")){bP("avoid_a",cd,"arguments."+F)}else{if(!az.evil&&cd&&cd.string==="document"&&(F==="write"||F==="writeln")){bP("write_is_wrong",cd)}else{if(az.adsafe){if(!bh&&cd.string==="ADSAFE"){if(F==="id"||F==="lib"){bP("adsafe_a",ax)}else{if(F==="go"){if(bV!=="script"){bP("adsafe_a",ax)}else{if(t||I.id!=="("||av(0).id!=="(string)"||av(0).string!==k||av(1).id!==","){aQ("adsafe_a",ax,"go")}}t=true;ao=false}}}bh=false}}}if(!az.evil&&(F==="eval"||F==="execScript")){bP("evil")}else{if(az.safe){for(;;){if(ad[F]===true){bP("adsafe_a",ay,F)}if(typeof b8[cd.string]!=="boolean"||I.id==="("){break}if(I.id!=="."){bP("adsafe_a",ax);break}f(".");ay.first=ax;ay.second=F;ax=ay;F=aj();if(typeof F==="string"){bK(F)}}}}return ax},true);aH("[",170,function(ce,ax){var cd,F;b2(bS,ay);P();bR();aq();cd=a(0);switch(cd.id){case"(number)":if(cd.id==="(number)"&&ce.id==="arguments"){bP("use_param",ce)}break;case"(string)":if(az.safe&&(ad[cd.string]||cd.string.charAt(0)==="_"||cd.string.slice(-1)==="_")){bP("adsafe_subscript_a",cd)}else{if(!az.evil&&(cd.string==="eval"||cd.string==="execScript")){bP("evil",cd)}else{if(!az.sub&&D.test(cd.string)){F=r[cd.string];if(!F||!F.reserved){bP("subscript",cd)}}}}bK(cd.string);break;default:if(az.safe){bP("adsafe_subscript_a",cd)}}bs("]",ax);P(bS,ay);ax.first=ce;ax.second=cd;return ax},true);bL("[",function(){this.arity="prefix";this.first=[];bR("array");while(I.id!=="(end)"){while(I.id===","){bP("unexpected_a",I);f(",")}if(I.id==="]"){break}j.wrap=false;aq();this.first.push(a(10));if(I.id===","){aN();if(I.id==="]"&&!az.es5){bP("unexpected_a",ay);break}}else{break}}bs("]",this);return this},170);function am(){var F=a0(true);if(!F){if(I.id==="(string)"){F=I.string;if(az.safe){if(ad[F]){bP("adsafe_a")}else{if(F.charAt(0)==="_"||F.charAt(F.length-1)==="_"){bP("dangling_a")}}}f()}else{if(I.id==="(number)"){F=I.number.toString();f()}}}return F}function a7(){var cd,F=I,ax=[];f("(");bR();P();if(I.id===")"){P();bs(")",F);return ax}for(;;){aq();cd=aj();ax.push(ay);m(ay,az.unparam?"parameter":"unparam");if(I.id===","){aN()}else{P();bs(")",F);return ax}}}function aY(cd,ax){var ce=U,cf=az,F=B;U={"(name)":ax||"'"+(a9||"").replace(bw,bm)+"'","(line)":I.line,"(context)":ce,"(breakage)":0,"(loopage)":0,"(scope)":B,"(token)":cd};az=Object.create(cf);B=Object.create(F);bF.push(U);cd.name=ax;if(ax){m(cd,"function",ax)}cd.writeable=false;cd.first=U["(params)"]=a7();bb();cd.block=b7(false);if(U["(arguments)"]){cd.first.forEach(function(cg){if(cg.assign){bP("parameter_arguments_a",cg,cg.string)}})}U=ce;az=cf;B=F}bc("=");bc("+=","+");bc("-=","-");bc("*=","*");bc("/=","/").nud=function(){aQ("slash_equal")};bc("%=","%");bc("&=","&");bc("|=","|");bc("^=","^");bc("<<=","<<");bc(">>=",">>");bc(">>>=",">>>");bL("{",function(){var ce,cf,cd,ax,cg,ch,F={};this.arity="prefix";this.first=[];bR();while(I.id!=="}"){j.wrap=false;aq();if(I.string==="get"&&av().id!==":"){if(!az.es5){bP("es5")}ce=I;f("get");bt();ax=I;cf=am();if(!cf){aQ("missing_property")}ce.string="";aY(ce);if(U["(loopage)"]){bP("function_loop",ce)}cg=ce.first;if(cg){bP("parameter_a_get_b",cg[0],cg[0].string,cf)}aN();ch=I;G();aq();f("set");ch.string="";bt();cd=am();if(cf!==cd){aQ("expected_a_b",ay,cf,cd||I.string)}aY(ch);if(ch.block.length===0){bP("missing_a",ay,"throw")}cg=ch.first;if(!cg||cg.length!==1){aQ("parameter_set_a",ch,"value")}else{if(cg[0].string!=="value"){aQ("expected_a_b",cg[0],"value",cg[0].string)}}ax.first=[ce,ch]}else{ax=I;cf=am();if(typeof cf!=="string"){aQ("missing_property")}f(":");G();ax.first=a(10)}this.first.push(ax);if(F[cf]===true){bP("duplicate_a",I,cf)}F[cf]=true;bK(cf);if(I.id!==","){break}for(;;){aN();if(I.id!==","){break}bP("unexpected_a",I)}if(I.id==="}"&&!az.es5){bP("unexpected_a",ay)}}bs("}",this);return this});bo("{",function(){bP("statement_block");this.arity="statement";this.block=ae();this.disrupt=this.block.disrupt;f("}",this);return this});bo("/*global",aO);bo("/*globals",aO);bo("/*jslint",aO);bo("/*member",aO);bo("/*members",aO);bo("/*property",aO);bo("/*properties",aO);bo("var",function(){var F,cd,ax;if(U["(vars)"]&&!az.vars){bP("combine_var")}else{if(U!==bk){U["(vars)"]=true}}this.arity="statement";this.first=[];bR("var");for(;;){ax=I;cd=aj();m(ax,"becoming");if(I.id==="="){F=I;F.first=ax;G();f("=");G();if(I.id==="undefined"){bP("unnecessary_initialize",ay,cd)}if(av(0).id==="="&&I.identifier){aQ("var_a_not")}F.second=a(0);F.arity="infix";this.first.push(F)}else{this.first.push(ax)}if(U[cd]==="becoming"){U[cd]="unused"}if(I.id!==","){break}aN();j.wrap=false;if(a4&&I.line===ay.line&&this.first.length===1){a4=null;j.open=false;j.at-=az.indent}G();aq()}a4=null;bs();return this});bo("function",function(){bb();if(aU){bP("function_block",ay)}var F=I,ax=aj();m(F,"unction");P();this.arity="statement";aY(this,ax);if(I.id==="("&&I.line===ay.line){aQ("function_statement")}return this});bL("function",function(){if(!az.anon){bb()}var F=a0();if(F){P()}else{F=""}aY(this,F);if(U["(loopage)"]){bP("function_loop")}switch(I.id){case";":case"(":case")":case",":case"]":case"}":case":":break;case".":if(av().string!=="bind"||av(1).id!=="("){bP("unexpected_a")}break;default:aQ("unexpected_a")}this.arity="function";return this});bo("if",function(){var F=I;bb();f("(");bR("control");P();aq();this.arity="statement";this.first=Y(a2(a(0)));P();bs(")",F);bb();this.block=b7(true);if(I.id==="else"){bb();f("else");bb();this["else"]=I.id==="if"||I.id==="switch"?aL(true):b7(true);if(this["else"].disrupt&&this.block.disrupt){this.disrupt=true}}return this});bo("try",function(){var ax,F,cd;if(az.adsafe){bP("adsafe_a",this)}bb();this.arity="statement";this.block=b7(false);if(I.id==="catch"){bb();f("catch");bb();cd=I;f("(");bR("control");P();aq();F=B;B=Object.create(F);ax=I.string;this.first=ax;if(!I.identifier){bP("expected_identifier_a",I)}else{m(I,"exception")}f();P();bs(")",cd);bb();this.second=b7(false);B=F}if(I.id==="finally"){bb();f("finally");bb();this.third=b7(false)}else{if(!this.second){aQ("expected_a_b",I,"catch",ac())}}return this});bQ("while",function(){bb();var F=I;U["(breakage)"]+=1;U["(loopage)"]+=1;f("(");bR("control");P();aq();this.arity="statement";this.first=a2(a(0));if(this.first.id!=="true"){Y(this.first,A.unexpected_a)}P();bs(")",F);bb();this.block=b7(true);if(this.block.disrupt){bP("strange_loop",bS)}U["(breakage)"]-=1;U["(loopage)"]-=1;return this});h("with");bQ("switch",function(){var ax=[],ce=aU,cg,cf=I,cd=true;function F(ch){if(a6(cg,ch)){bP("duplicate_a",ch)}}U["(breakage)"]+=1;bb();f("(");P();bR();this.arity="statement";this.first=Y(a2(a(0)));P();bs(")",cf);bb();f("{");bR();aU=true;this.second=[];while(I.id==="case"){cf=I;ax.forEach(F);cf.first=[];cf.arity="case";G();aq("case");f("case");for(;;){bb();cg=a(0);ax.forEach(F);ax.push(cg);cf.first.push(cg);if(cg.id==="NaN"){bP("unexpected_a",cg)}b2();f(":");if(I.id!=="case"){break}G();aq("case");f("case")}G();cf.second=ae();if(cf.second&&cf.second.length>0){cg=cf.second[cf.second.length-1];if(cg.disrupt){if(cg.id==="break"){cd=false}}else{bP("missing_a_after_b",I,"break","case")}}else{bP("empty_case")}this.second.push(cf)}if(this.second.length===0){bP("missing_a",I,"case")}if(I.id==="default"){G();cf=I;cf.arity="case";aq("case");f("default");b2();f(":");G();cf.second=ae();if(cf.second&&cf.second.length>0){cg=cf.second[cf.second.length-1];if(cd&&cg.disrupt&&cg.id!=="break"){this.disrupt=true}}this.second.push(cf)}U["(breakage)"]-=1;G();bs("}",this);aU=ce;return this});bo("debugger",function(){if(!az.debug){bP("unexpected_a",this)}this.arity="statement";return this});bQ("do",function(){U["(breakage)"]+=1;U["(loopage)"]+=1;bb();this.arity="statement";this.block=b7(true);if(this.block.disrupt){bP("strange_loop",bS)}bb();f("while");var F=I;bb();f("(");bR();P();aq();this.first=Y(a2(a(0)),A.unexpected_a);P();bs(")",F);U["(breakage)"]-=1;U["(loopage)"]-=1;return this});bQ("for",function(){var ax,ce,F=false,cd=I,cf;this.arity="statement";U["(breakage)"]+=1;U["(loopage)"]+=1;f("(");if(I.id===";"){P();f(";");P();f(";");P();f(")");ax=b7(true)}else{bR("control");G(this,cd);P();if(I.id==="var"){aQ("move_var")}aq();if(av(0).id==="in"){this.forin=true;cf=I;switch(U[cf.string]){case"unused":U[cf.string]="var";break;case"closure":case"var":break;default:bP("bad_in_a",cf)}f();f("in");this.first=cf;this.second=a(20);bs(")",cd);ax=b7(true);if(!az.forin){if(ax.length===1&&typeof ax[0]==="object"&&ax[0].string==="if"&&!ax[0]["else"]){ce=ax[0].first;while(ce.id==="&&"){ce=ce.first}switch(ce.id){case"===":case"!==":F=ce.first.id==="["?ce.first.first.string===this.second.string&&ce.first.second.string===this.first.string:ce.first.id==="typeof"&&ce.first.first.id==="["&&ce.first.first.first.string===this.second.string&&ce.first.first.second.string===this.first.string;break;case"(":F=ce.first.id==="."&&((ce.first.first.string===this.second.string&&ce.first.second.string==="hasOwnProperty"&&ce.second[0].string===this.first.string)||(ce.first.first.string==="ADSAFE"&&ce.first.second.string==="has"&&ce.second[0].string===this.second.string&&ce.second[1].string===this.first.string)||(ce.first.first.id==="."&&ce.first.first.first.id==="."&&ce.first.first.first.first.string==="Object"&&ce.first.first.first.second.string==="prototype"&&ce.first.first.second.string==="hasOwnProperty"&&ce.first.second.string==="call"&&ce.second[0].string===this.second.string&&ce.second[1].string===this.first.string));break}}if(!F){bP("for_if",this)}}}else{aq();this.first=[];for(;;){this.first.push(a(0,"for"));if(I.id!==","){break}aN()}ak();aq();this.second=a2(a(0));if(this.second.id!=="true"){Y(this.second,A.unexpected_a)}ak(ay);if(I.id===";"){aQ("expected_a_b",I,")",";")}this.third=[];aq();for(;;){this.third.push(a(0,"for"));if(I.id!==","){break}aN()}P();bs(")",cd);bb();ax=b7(true)}}if(ax.disrupt){bP("strange_loop",bS)}this.block=ax;U["(breakage)"]-=1;U["(loopage)"]-=1;return this});bN("break",function(){var F=I.string;this.arity="statement";if(U["(breakage)"]===0){bP("unexpected_a",this)}if(I.identifier&&ay.line===I.line){bt();if(U[F]!=="label"){bP("not_a_label",I)}else{if(B[F].funct!==U){bP("not_a_scope",I)}}this.first=I;f()}return this});bN("continue",function(){if(!az["continue"]){bP("unexpected_a",this)}var F=I.string;this.arity="statement";if(U["(breakage)"]===0){bP("unexpected_a",this)}if(I.identifier&&ay.line===I.line){bt();if(U[F]!=="label"){bP("not_a_label",I)}else{if(B[F].funct!==U){bP("not_a_scope",I)}}this.first=I;f()}return this});bN("return",function(){if(U===bk&&bV!=="scriptstring"){bP("unexpected_a",this)}this.arity="statement";if(I.id!==";"&&I.line===ay.line){bt();if(I.id==="/"||I.id==="(regexp)"){bP("wrap_regexp")}this.first=a(20)}if(av(0).id==="}"&&av(1).id==="else"){bP("unexpected_else",this)}return this});bN("throw",function(){this.arity="statement";bt();this.first=a(20);return this});h("class");h("const");h("enum");h("export");h("extends");h("import");h("super");h("implements");h("interface");h("let");h("package");h("private");h("protected");h("public");h("static");h("yield");function aw(){function ax(){var ce=I,cd={};f("{");if(I.id!=="}"){while(I.id!=="(end)"){while(I.id===","){bP("unexpected_a",I);f(",")}if(I.id!=="(string)"){bP("expected_string_a")}if(cd[I.string]===true){bP("duplicate_a")}else{if(I.string==="__proto__"){bP("dangling_a")}else{cd[I.string]=true}}f();f(":");aw();if(I.id!==","){break}f(",");if(I.id==="}"){bP("unexpected_a",ay);break}}}f("}",ce)}function F(){var cd=I;f("[");if(I.id!=="]"){while(I.id!=="(end)"){while(I.id===","){bP("unexpected_a",I);f(",")}aw();if(I.id!==","){break}f(",");if(I.id==="]"){bP("unexpected_a",ay);break}}}f("]",cd)}switch(I.id){case"{":ax();break;case"[":F();break;case"true":case"false":case"null":case"(number)":case"(string)":f();break;case"-":f("-");b2();f("(number)");break;default:aQ("unexpected_a")}}function au(){if(I.identifier){f();return true}}function ai(){if(I.id==="-"){f("-");b2()}if(I.id==="(number)"){f("(number)");return true}}function bn(){if(I.id==="(string)"){f();return true}}function a3(){var F,cd,ax,ce;if(I.identifier){ce=I.string;if(ce==="rgb"||ce==="rgba"){f();ax=I;f("(");for(F=0;F<3;F+=1){if(F){aN()}cd=I.number;if(I.id!=="(number)"||cd<0){bP("expected_positive_a",I);f()}else{f();if(I.id==="%"){f("%");if(cd>100){bP("expected_percent_a",ay,cd)}}else{if(cd>255){bP("expected_small_a",ay,cd)}}}}if(ce==="rgba"){aN();cd=I.number;if(I.id!=="(number)"||cd<0||cd>1){bP("expected_fraction_a",I)}f();if(I.id==="%"){bP("unexpected_a");f("%")}}f(")",ax);return true}if(aB[I.string]===true){f();return true}}else{if(I.id==="(color)"){f();return true}}return false}function bz(){if(I.id==="-"){f("-");b2()}if(I.id==="(number)"){f();if(I.id!=="(string)"&&S[I.string]===true){b2();f()}else{if(+ay.number!==0){bP("expected_linear_a")}}return true}return false}function N(){if(I.id==="-"){f("-");b2()}if(I.id==="(number)"){f();if(I.id!=="(string)"&&S[I.string]===true){b2();f()}return true}return false}function at(){if(I.identifier){switch(I.string){case"thin":case"medium":case"thick":f();return true}}else{return bz()}}function b0(){if(I.identifier){if(I.string==="auto"){f();return true}}else{return bz()}}function ah(){if(I.identifier&&I.string==="attr"){f();f("(");if(!I.identifier){bP("expected_name_a")}f();f(")");return true}return false}function aC(){while(I.id!==";"){if(!au()&&!bn()){bP("expected_name_a")}if(I.id!==","){return true}aN()}}function bx(){if(I.identifier&&I.string==="counter"){f();f("(");f();if(I.id===","){aN();if(I.id!=="(string)"){bP("expected_string_a")}f()}f(")");return true}if(I.identifier&&I.string==="counters"){f();f("(");if(!I.identifier){bP("expected_name_a")}f();if(I.id===","){aN();if(I.id!=="(string)"){bP("expected_string_a")}f()}if(I.id===","){aN();if(I.id!=="(string)"){bP("expected_string_a")}f()}f(")");return true}return false}function E(){return bz()&&(I.id!=="(number)"||bz())}function x(){var F;if(I.identifier&&I.string==="rect"){f();f("(");for(F=0;F<4;F+=1){if(!bz()){bP("expected_number_a");break}}f(")");return true}return false}function aG(){var ax,F;if(I.identifier&&I.string==="url"){I=aK.range("(",")");F=I.string;ax=F.charAt(0);if(ax==='"'||ax==="'"){if(F.slice(-1)!==ax){bP("bad_url_a")}else{F=F.slice(1,-1);if(F.indexOf(ax)>=0){bP("bad_url_a")}}}if(!F){bP("missing_url")}if(K.test(F)){aQ("bad_url_a")}V.push(F);f();return true}return false}b5=[aG,function(){for(;;){if(I.identifier){switch(I.string.toLowerCase()){case"url":aG();break;case"expression":bP("unexpected_a");f();break;default:f()}}else{if(I.id===";"||I.id==="!"||I.id==="(end)"||I.id==="}"){return true}f()}}}];function a8(){J("font-family");f(":");if(!au()&&!bn()){aQ("expected_name_a")}ak();J("src");f(":");while(true){if(I.string==="local"){J("local");f("(");if(K.test(I.string)){aQ("bad_url_a")}if(!au()&&!bn()){aQ("expected_name_a")}f(")")}else{if(!aG()){aQ("expected_a_b",I,"url",ac())}}if(I.id!==","){break}aN()}ak()}L=["none","dashed","dotted","double","groove","hidden","inset","outset","ridge","solid"];ab=["auto","always","avoid","left","right"];Q={all:true,braille:true,embossed:true,handheld:true,print:true,projection:true,screen:true,speech:true,tty:true,tv:true};cb=["auto","hidden","scroll","visible"];bU={background:[true,"background-attachment","background-color","background-image","background-position","background-repeat"],"background-attachment":["scroll","fixed"],"background-color":["transparent",a3],"background-image":["none",aG],"background-position":[2,[bz,"top","bottom","left","right","center"]],"background-repeat":["repeat","repeat-x","repeat-y","no-repeat"],border:[true,"border-color","border-style","border-width"],"border-bottom":[true,"border-bottom-color","border-bottom-style","border-bottom-width"],"border-bottom-color":a3,"border-bottom-left-radius":E,"border-bottom-right-radius":E,"border-bottom-style":L,"border-bottom-width":at,"border-collapse":["collapse","separate"],"border-color":["transparent",4,a3],"border-left":[true,"border-left-color","border-left-style","border-left-width"],"border-left-color":a3,"border-left-style":L,"border-left-width":at,"border-radius":function(){function F(ax){var cd=1;if(ax){f(ax)}if(!bz()){return false}while(I.id==="(number)"){if(!bz()){return false}cd+=1}if(cd>4){bP("bad_style")}return true}return F()&&(I.id!=="/"||F("/"))},"border-right":[true,"border-right-color","border-right-style","border-right-width"],"border-right-color":a3,"border-right-style":L,"border-right-width":at,"border-spacing":[2,bz],"border-style":[4,L],"border-top":[true,"border-top-color","border-top-style","border-top-width"],"border-top-color":a3,"border-top-left-radius":E,"border-top-right-radius":E,"border-top-style":L,"border-top-width":at,"border-width":[4,at],bottom:[bz,"auto"],"caption-side":["bottom","left","right","top"],clear:["both","left","none","right"],clip:[x,"auto"],color:a3,content:["open-quote","close-quote","no-open-quote","no-close-quote",bn,aG,bx,ah],"counter-increment":[au,"none"],"counter-reset":[au,"none"],cursor:[aG,"auto","crosshair","default","e-resize","help","move","n-resize","ne-resize","nw-resize","pointer","s-resize","se-resize","sw-resize","w-resize","text","wait"],direction:["ltr","rtl"],display:["block","compact","inline","inline-block","inline-table","list-item","marker","none","run-in","table","table-caption","table-cell","table-column","table-column-group","table-footer-group","table-header-group","table-row","table-row-group"],"empty-cells":["show","hide"],"float":["left","none","right"],font:["caption","icon","menu","message-box","small-caption","status-bar",true,"font-size","font-style","font-weight","font-family"],"font-family":aC,"font-size":["xx-small","x-small","small","medium","large","x-large","xx-large","larger","smaller",bz],"font-size-adjust":["none",ai],"font-stretch":["normal","wider","narrower","ultra-condensed","extra-condensed","condensed","semi-condensed","semi-expanded","expanded","extra-expanded"],"font-style":["normal","italic","oblique"],"font-variant":["normal","small-caps"],"font-weight":["normal","bold","bolder","lighter",ai],height:[bz,"auto"],left:[bz,"auto"],"letter-spacing":["normal",bz],"line-height":["normal",N],"list-style":[true,"list-style-image","list-style-position","list-style-type"],"list-style-image":["none",aG],"list-style-position":["inside","outside"],"list-style-type":["circle","disc","square","decimal","decimal-leading-zero","lower-roman","upper-roman","lower-greek","lower-alpha","lower-latin","upper-alpha","upper-latin","hebrew","katakana","hiragana-iroha","katakana-oroha","none"],margin:[4,b0],"margin-bottom":b0,"margin-left":b0,"margin-right":b0,"margin-top":b0,"marker-offset":[bz,"auto"],"max-height":[bz,"none"],"max-width":[bz,"none"],"min-height":bz,"min-width":bz,opacity:ai,outline:[true,"outline-color","outline-style","outline-width"],"outline-color":["invert",a3],"outline-style":["dashed","dotted","double","groove","inset","none","outset","ridge","solid"],"outline-width":at,overflow:cb,"overflow-x":cb,"overflow-y":cb,padding:[4,bz],"padding-bottom":bz,"padding-left":bz,"padding-right":bz,"padding-top":bz,"page-break-after":ab,"page-break-before":ab,position:["absolute","fixed","relative","static"],quotes:[8,bn],right:[bz,"auto"],"table-layout":["auto","fixed"],"text-align":["center","justify","left","right"],"text-decoration":["none","underline","overline","line-through","blink"],"text-indent":bz,"text-shadow":["none",4,[a3,bz]],"text-transform":["capitalize","uppercase","lowercase","none"],top:[bz,"auto"],"unicode-bidi":["normal","embed","bidi-override"],"vertical-align":["baseline","bottom","sub","super","top","text-top","middle","text-bottom",bz],visibility:["visible","hidden","collapse"],"white-space":["normal","nowrap","pre","pre-line","pre-wrap","inherit"],width:[bz,"auto"],"word-spacing":["normal",bz],"word-wrap":["break-word","normal"],"z-index":["auto",ai]};function s(){var F;while(I.id==="*"||I.id==="#"||I.string==="_"){if(!az.css){bP("unexpected_a")}f()}if(I.id==="-"){if(!az.css){bP("unexpected_a")}f("-");if(!I.identifier){bP("expected_nonstandard_style_attribute")}f();return b5}if(!I.identifier){bP("expected_style_attribute")}else{if(Object.prototype.hasOwnProperty.call(bU,I.string)){F=bU[I.string]}else{F=b5;if(!az.css){bP("unrecognized_style_attribute_a")}}}f();return F}function aJ(ax){var ce=0,ci,cf,cd,F,ch=0,cg;switch(typeof ax){case"function":return ax();case"string":if(I.identifier&&I.string===ax){f();return true}return false}for(;;){if(ce>=ax.length){return false}cg=ax[ce];ce+=1;if(typeof cg==="boolean"){break}else{if(typeof cg==="number"){ci=cg;cg=ax[ce];ce+=1}else{ci=1}}cd=false;while(ci>0){if(aJ(cg)){cd=true;ci-=1}else{break}}if(cd){return true}}ch=ce;cf=[];for(;;){F=false;for(ce=ch;ce<ax.length;ce+=1){if(!cf[ce]){if(aJ(bU[ax[ce]])){cd=true;F=true;cf[ce]=true;break}}}if(!F){return cd}}}function a5(){if(I.id==="(number)"){f();if(I.string==="n"&&I.identifier){b2();f();if(I.id==="+"){b2();f("+");b2();f("(number)")}}return}if(I.identifier&&(I.string==="odd"||I.string==="even")){f();return}bP("unexpected_a")}function W(){var F;for(;;){if(I.id==="}"||I.id==="(end)"||(R&&I.id===R)){return}F=s();f(":");if(I.identifier&&I.string==="inherit"){f()}else{if(!aJ(F)){bP("unexpected_a");f()}}if(I.id==="!"){f("!");b2();if(I.identifier&&I.string==="important"){f()}else{bP("expected_a_b",I,"important",ac())}}if(I.id==="}"||I.id===R){bP("expected_a_b",I,";",ac())}else{ak()}}}function bO(){if(I.identifier){if(!Object.prototype.hasOwnProperty.call(br,az.cap?I.string.toLowerCase():I.string)){bP("expected_tagname_a")}f()}else{switch(I.id){case">":case"+":f();bO();break;case":":f(":");switch(I.string){case"active":case"after":case"before":case"checked":case"disabled":case"empty":case"enabled":case"first-child":case"first-letter":case"first-line":case"first-of-type":case"focus":case"hover":case"last-child":case"last-of-type":case"link":case"only-of-type":case"root":case"target":case"visited":J(I.string);break;case"lang":J("lang");f("(");if(!I.identifier){bP("expected_lang_a")}f(")");break;case"nth-child":case"nth-last-child":case"nth-last-of-type":case"nth-of-type":J(I.string);f("(");a5();f(")");break;case"not":J("not");f("(");if(I.id===":"&&av(0).string==="not"){bP("not")}bO();f(")");break;default:bP("expected_pseudo_a")}break;case"#":f("#");if(!I.identifier){bP("expected_id_a")}f();break;case"*":f("*");break;case".":f(".");if(!I.identifier){bP("expected_class_a")}f();break;case"[":f("[");if(!I.identifier){bP("expected_attribute_a")}f();if(I.id==="="||I.string==="~="||I.string==="$="||I.string==="|="||I.id==="*="||I.id==="^="){f();if(I.id!=="(string)"){bP("expected_string_a")}f()}f("]");break;default:aQ("expected_selector_a")}}}function aP(){if(I.id==="{"){bP("expected_style_pattern")}for(;;){bO();if(I.id==="</"||I.id==="{"||I.id==="}"||I.id==="(end)"){return""}if(I.id===","){aN()}}}function bj(){while(I.id!=="}"&&I.id!=="</"&&I.id!=="(end)"){aP();bV="styleproperty";if(I.id===";"){ak()}else{f("{");W();bV="style";f("}")}}}function be(){var F;while(I.id==="@"){F=av();f("@");switch(I.string){case"import":J("import");if(!aG()){bP("expected_a_b",I,"url",ac());f()}ak();break;case"media":J("media");for(;;){if(!I.identifier||Q[I.string]!==true){aQ("expected_media_a")}f();if(I.id!==","){break}aN()}f("{");bj();f("}");break;case"font-face":J("font-face");f("{");a8();f("}");break;default:aQ("expected_at_a")}}bj()}function i(F){if(F!=="html"&&!az.fragment){if(F==="div"&&az.adsafe){aQ("adsafe_fragment")}else{aQ("expected_a_b",ay,"html",F)}}if(az.adsafe){if(F==="html"){aQ("adsafe_html",ay)}if(az.fragment){if(F!=="div"){aQ("adsafe_div",ay)}}else{aQ("adsafe_fragment",ay)}}az.browser=true}function an(ax,cd){var ce,F;if(ax==="id"){ce=typeof cd==="string"?cd.toUpperCase():"";if(u[ce]===true){bP("duplicate_a",I,cd)}if(!/^[A-Za-z][A-Za-z0-9._:\-]*$/.test(cd)){bP("bad_id_a",I,cd)}else{if(az.adsafe){if(k){if(cd.slice(0,k.length)!==k){bP("adsafe_prefix_a",I,k)}else{if(!/^[A-Z]+_[A-Z]+$/.test(cd)){bP("adsafe_bad_id")}}}else{k=cd;if(!/^[A-Z]+_$/.test(cd)){bP("adsafe_bad_id")}}}}F=cd.search(aT);if(F>=0){bP("unexpected_char_a_b",ay,cd.charAt(F),ax)}u[ce]=true}else{if(ax==="class"||ax==="type"||ax==="name"){F=cd.search(aM);if(F>=0){bP("unexpected_char_a_b",ay,cd.charAt(F),ax)}u[ce]=true}else{if(ax==="href"||ax==="background"||ax==="content"||ax==="data"||ax.indexOf("src")>=0||ax.indexOf("url")>=0){if(az.safe&&K.test(cd)){aQ("bad_url_a",I,cd)}V.push(cd)}else{if(ax==="for"){if(az.adsafe){if(k){if(cd.slice(0,k.length)!==k){bP("adsafe_prefix_a",I,k)}else{if(!/^[A-Z]+_[A-Z]+$/.test(cd)){bP("adsafe_bad_id")}}}else{bP("adsafe_bad_id")}}}else{if(ax==="name"){if(az.adsafe&&cd.indexOf("_")>=0){bP("adsafe_name_a",I,cd)}}}}}}}function bM(ce,cg){var cf,ax=br[ce],cd,F;b6=false;if(!ax){aQ(A.unrecognized_tag_a,I,ce===ce.toLowerCase()?ce:ce+" (capitalization error)")}if(d.length>0){if(ce==="html"){aQ("unexpected_a",ay,ce)}F=ax.parent;if(F){if(F.indexOf(" "+d[d.length-1].name+" ")<0){aQ("tag_a_in_b",ay,ce,F)}}else{if(!az.adsafe&&!az.fragment){cf=d.length;do{if(cf<=0){aQ("tag_a_in_b",ay,ce,"body")}cf-=1}while(d[cf].name!=="body")}}}switch(ce){case"div":if(az.adsafe&&d.length===1&&!k){bP("adsafe_missing_id")}break;case"script":bV="script";f(">");if(cg.lang){bP("lang",ay)}if(az.adsafe&&d.length!==1){bP("adsafe_placement",ay)}if(cg.src){if(az.adsafe&&(!ao||!bW[cg.src])){bP("adsafe_source",ay)}}else{bR(I.from);aq();w();bh=true;cd=ae();if(az.adsafe){if(t){aQ("adsafe_script",ay)}if(cd.length!==1||al(cd[0],"id","(")||al(cd[0].first,"id",".")||al(cd[0].first.first,"string","ADSAFE")||al(cd[0].second[0],"string",k)){aQ("adsafe_id_go")}switch(cd[0].first.second.string){case"id":if(ao||t||cd[0].second.length!==1){aQ("adsafe_id",I)}ao=true;break;case"go":if(t){aQ("adsafe_go")}if(cd[0].second.length!==2||al(cd[0].second[1],"id","function")||!cd[0].second[1].first||al(cd[0].second[1].first[0],"string","dom")||cd[0].second[1].first.length>2||(cd[0].second[1].first.length===2&&al(cd[0].second[1].first[1],"string","lib"))){aQ("adsafe_go",I)}t=true;break;default:aQ("adsafe_id_go")}}j=null}bV="html";f("</");J("script");bV="outer";break;case"style":bV="style";f(">");be();bV="html";f("</");J("style");break;case"input":switch(cg.type){case"button":case"checkbox":case"radio":case"reset":case"submit":break;case"file":case"hidden":case"image":case"password":case"text":if(az.adsafe&&cg.autocomplete!=="off"){bP("adsafe_autocomplete")}break;default:bP("bad_type")}break;case"applet":case"body":case"embed":case"frame":case"frameset":case"head":case"iframe":case"noembed":case"noframes":case"object":case"param":if(az.adsafe){bP("adsafe_tag",I,ce)}break}}function M(F){return"</"+F+">"}function ap(){var cf,ch,cg,ax,ci=az.white,F,ce,cj,cd;bV="html";R="";d=null;for(;;){switch(I.string){case"<":bV="html";f("<");ch={};ce=I;ax=ce.string;J(ax);if(az.cap){ax=ax.toLowerCase()}ce.name=ax;if(!d){d=[];i(ax)}cj=br[ax];if(typeof cj!=="object"){aQ("unrecognized_tag_a",ce,ax)}cg=cj.empty;ce.type=ax;for(;;){if(I.id==="/"){f("/");if(I.id!==">"){bP("expected_a_b",I,">",ac())}break}if(I.id&&I.id.charAt(0)===">"){break}if(!I.identifier){if(I.id==="(end)"||I.id==="(error)"){bP("expected_a_b",I,">",ac())}bP("bad_name_a")}az.white=false;G();cf=I.string;az.white=ci;f();if(!az.cap&&cf!==cf.toLowerCase()){bP("attribute_case_a",ay)}cf=cf.toLowerCase();R="";if(Object.prototype.hasOwnProperty.call(ch,cf)){bP("duplicate_a",ay,cf)}if(cf.slice(0,2)==="on"){if(!az.on){bP("html_handlers")}bV="scriptstring";f("=");F=I.id;if(F!=='"'&&F!=="'"){aQ("expected_a_b",I,'"',ac())}R=F;cd=az.white;az.white=true;f(F);w();ae();az.white=cd;if(I.id!==F){aQ("expected_a_b",I,F,ac())}bV="html";R="";f(F);cj=false}else{if(cf==="style"){bV="scriptstring";f("=");F=I.id;if(F!=='"'&&F!=="'"){aQ("expected_a_b",I,'"',ac())}bV="styleproperty";R=F;f(F);W();bV="html";R="";f(F);cj=false}else{if(I.id==="="){f("=");cj=I.string;if(!I.identifier&&I.id!=='"'&&I.id!=="'"&&I.id!=="(string)"&&I.id!=="(string)"&&I.id!=="(color)"){bP("expected_attribute_value_a",ay,cf)}f()}else{cj=true}}}ch[cf]=cj;an(cf,cj)}bM(ax,ch);if(!cg){d.push(ce)}bV="outer";f(">");break;case"</":bV="html";f("</");if(!I.identifier){bP("bad_name_a")}ax=I.string;if(az.cap){ax=ax.toLowerCase()}f();if(!d){aQ("unexpected_a",I,M(ax))}ce=d.pop();if(!ce){aQ("unexpected_a",I,M(ax))}if(ce.name!==ax){aQ("expected_a_b",I,M(ce.name),M(ax))}if(I.id!==">"){aQ("expected_a_b",I,">",ac())}bV="outer";f(">");break;case"<!":if(az.safe){bP("adsafe_a")}bV="html";for(;;){f();if(I.id===">"||I.id==="(end)"){break}if(I.string.indexOf("--")>=0){aQ("unexpected_a",I,"--")}if(I.string.indexOf("<")>=0){aQ("unexpected_a",I,"<")}if(I.string.indexOf(">")>=0){aQ("unexpected_a",I,">")}}bV="outer";f(">");break;case"(end)":if(d.length!==0){bP("missing_a",I,"</"+d.pop().string+">")}return;default:if(I.id==="(end)"){aQ("missing_a",I,"</"+d[d.length-1].string+">")}else{f()}}if(d&&d.length===0&&(az.adsafe||!az.fragment||I.id==="(end)")){break}}if(I.id!=="(end)"){aQ("unexpected_a")}}bJ=function aA(cg,ce){var cd,ax,F;JSLINT.errors=[];JSLINT.tree="";c=bS=ay=I=Object.create(r["(begin)"]);b8={};Z(bv);aa={};if(ce){az=Object.create(ce);ax=az.predef;if(ax){if(Array.isArray(ax)){for(cd=0;cd<ax.length;cd+=1){b8[ax[cd]]=true}}else{if(typeof ax==="object"){Z(ax)}}}aX()}else{az={}}az.indent=+az.indent||4;az.maxerr=+az.maxerr||50;k="";ao=bh=t=false;bW={};if(az.approved){for(cd=0;cd<az.approved.length;cd+=1){bW[az.approved[cd]]=az.approved[cd]}}else{bW.test="test"}bH="";for(cd=0;cd<az.indent;cd+=1){bH+=" "}a1=B={};bk=U={"(scope)":B,"(breakage)":0,"(loopage)":0};bF=[U];o=false;u={};aU=false;j=null;bY=false;ag=[];aW=false;q=true;b6=false;d=null;by=false;V=[];a4=null;g=0;bV="";aK.init(cg);bD();try{f();if(I.id==="(number)"){aQ("unexpected_a")}else{if(I.string.charAt(0)==="<"){ap();if(az.adsafe&&!t){bP("adsafe_go",this)}}else{switch(I.id){case"{":case"[":bY=true;aw();break;case"@":case"*":case"#":case".":case":":bV="style";f();if(ay.id!=="@"||!I.identifier||I.string!=="charset"||ay.line!==1||ay.from!==1){aQ("css")}f();if(I.id!=="(string)"&&I.string!=="UTF-8"){aQ("css")}f();ak();be();break;default:if(az.adsafe&&az.fragment){aQ("expected_a_b",I,"<div>",ac())}bR(1);if(I.id===";"&&!aW){ak()}bh=true;F=ae();c.first=F;JSLINT.tree=c;if(az.adsafe&&(F.length!==1||al(F[0],"id","(")||al(F[0].first,"id",".")||al(F[0].first.first,"string","ADSAFE")||al(F[0].first.second,"string","lib")||F[0].second.length!==2||F[0].second[0].id!=="(string)"||al(F[0].second[1],"id","function"))){aQ("adsafe_lib")}if(F.disrupt){bP("weird_program",bS)}}}}j=null;f("(end)")}catch(cf){if(cf){JSLINT.errors.push({reason:cf.message,line:cf.line||I.line,character:cf.character||I.from},null)}}return JSLINT.errors.length===0};bJ.data=function(){var ch={functions:[]},cl,ci,cj,cf,ce,cg=[],F,ck,cd=[],ax=[];if(bJ.errors.length){ch.errors=bJ.errors}if(bY){ch.json=true}if(V.length>0){ch.urls=V}ci=Object.keys(a1).filter(function(cm){return cm.charAt(0)!=="("&&typeof bv[cm]!=="boolean"});if(ci.length>0){ch.globals=ci}for(cj=1;cj<bF.length;cj+=1){ck=bF[cj];cl={};for(cf=0;cf<bq.length;cf+=1){cl[bq[cf]]=[]}for(F in ck){if(Object.prototype.hasOwnProperty.call(ck,F)){if(F.charAt(0)!=="("){ce=ck[F];if(ce==="unction"||ce==="unparam"){ce="unused"}if(Array.isArray(cl[ce])){cl[ce].push(F);if(ce==="unused"){ax.push({name:F,line:ck["(line)"],"function":ck["(name)"]})}else{if(ce==="undef"){cd.push({name:F,line:ck["(line)"],"function":ck["(name)"]})}}}}}}for(cf=0;cf<bq.length;cf+=1){if(cl[bq[cf]].length===0){delete cl[bq[cf]]}}cl.name=ck["(name)"];cl.params=ck["(params)"];cl.line=ck["(line)"];ch.functions.push(cl)}if(ax.length>0){ch.unused=ax}if(cd.length>0){ch["undefined"]=cd}cg=[];for(F in aa){if(typeof aa[F]==="number"){ch.member=aa;break}}return ch};bJ.report=function(ce){var cr=bJ.data(),ax,co,cm,cd,cl,cs,ch,F,cf="",ct,ci,cn,cg=[],cp,cj,ck;function cq(cv,cx){var cw,cu;if(Array.isArray(cx)){cg.push("<div><i>"+cv+"</i> ");cx.sort().forEach(function(cy){if(cy!==cu){cu=cy;cg.push((cw?", ":"")+cu);cw=true}});cg.push("</div>")}else{if(cx){cg.push("<div><i>"+cv+"</i> "+cx+"</div>")}}}if(cr.errors||cr.unused||cr["undefined"]){ax=true;cg.push("<div id=errors><i>Error:</i>");if(cr.errors){for(cm=0;cm<cr.errors.length;cm+=1){ck=cr.errors[cm];if(ck){co=ck.evidence||"";cg.push("<p>Problem"+(isFinite(ck.line)?" at line "+String(ck.line)+" character "+String(ck.character):"")+": "+ck.reason.entityify()+"</p><p class=evidence>"+(co&&(co.length>80?co.slice(0,77)+"...":co).entityify())+"</p>")}}}if(cr["undefined"]){cp=[];for(cm=0;cm<cr["undefined"].length;cm+=1){cp[cm]="<code><u>"+cr["undefined"][cm].name+"</u></code>&nbsp;<i>"+String(cr["undefined"][cm].line)+" </i> <small>"+cr["undefined"][cm]["function"]+"</small>"}cg.push("<p><i>Undefined variable:</i> "+cp.join(", ")+"</p>")}if(cr.unused){cp=[];for(cm=0;cm<cr.unused.length;cm+=1){cp[cm]="<code><u>"+cr.unused[cm].name+"</u></code>&nbsp;<i>"+String(cr.unused[cm].line)+" </i> <small>"+cr.unused[cm]["function"]+"</small>"}cg.push("<p><i>Unused variable:</i> "+cp.join(", ")+"</p>")}if(cr.json){cg.push("<p>JSON: bad.</p>")}cg.push("</div>")}if(!ce){cg.push("<br><div id=functions>");if(cr.urls){cq("URLs<br>",cr.urls,"<br>")}if(bV==="style"){cg.push("<p>CSS.</p>")}else{if(cr.json&&!ax){cg.push("<p>JSON: good.</p>")}else{if(cr.globals){cg.push("<div><i>Global</i> "+cr.globals.sort().join(", ")+"</div>")}else{cg.push("<div><i>No new global variables introduced.</i></div>")}}}for(cm=0;cm<cr.functions.length;cm+=1){cj=cr.functions[cm];ci=[];if(cj.params){for(cl=0;cl<cj.params.length;cl+=1){ci[cl]=cj.params[cl].string}}cg.push("<br><div class=function><i>"+String(cj.line)+"</i> "+cj.name.entityify()+"("+ci.join(", ")+")</div>");cq("<big><b>Undefined</b></big>",cj["undefined"]);cq("<big><b>Unused</b></big>",cj.unused);cq("Closure",cj.closure);cq("Variable",cj["var"]);cq("Exception",cj.exception);cq("Outer",cj.outer);cq("Global",cj.global);cq("Label",cj.label)}if(cr.member){ch=Object.keys(cr.member);if(ch.length){ch=ch.sort();cg.push("<br><pre id=properties>/*properties<br>");cf="    ";cd=0;cl=0;cn=false;for(cm=0;cm<ch.length;cm+=1){cs=ch[cm];if(cr.member[cs]>0){if(cn){cf+=", "}ct=D.test(cs)?cs:"'"+cs.entityify().replace(bw,bm)+"'";F+=ct.length+2;if(cr.member[cs]===1){ct="<i>"+ct+"</i>";cd+=1;cl=1}if(cf.length+ct.length-(cd*7)>80){cg.push(cf+"<br>");cf="    ";cd=cl}cf+=ct;cl=0;cn=true}}cg.push(cf+"<br>*/</pre>")}cg.push("</div>")}}return cg.join("")};bJ.jslint=bJ;bJ.edition="2012-03-02";return bJ}());